{Aldarin's Topfield PVR Components Suite 1.1
Copyright 2004, 2005 by Aldarin
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

unit TopfieldReceiver;

interface

uses Classes, Messages, SysUtils, Windows, Forms, tfdllex;

{added by FireBird for Delphi 2005 - 20.06.2005

 SYMBOL COMPILER VERSION
 VER80  Delphi 1
 VER90  Delphi 2
 VER100 Delphi 3
 VER120 Delphi 4
 VER130 Delphi 5
 VER140 Delphi 6
 VER150 Delphi 7
 VER160 Delphi 8
 VER170 Delphi 2005}

{$IFDEF VER170}
resourcestring SFCreateError = 'Illegal value: %s';
resourcestring SFOpenError = 'Illegal value: %s';
{$ENDIF}

{added by Lucky B for Delphi6 - 08.04.2005}
{$IFDEF VER140}
resourcestring SFCreateError = 'Illegal value: %s';
resourcestring SFOpenError = 'Illegal value: %s';
{$ENDIF}

const
{------------------------------------------------------------------------------}
{ Translated from DBT.H }
{------------------------------------------------------------------------------}
	DBT_DEVTYP_DEVICEINTERFACE		= $00000005;
	DBT_DEVICEARRIVAL				= $8000;
	DBT_DEVICEREMOVECOMPLETE    	= $8004;
{------------------------------------------------------------------------------}
{ Own definitions }
{------------------------------------------------------------------------------}
{ Device messages }
	DEVICE_ARRIVAL_MSG				= 3000; // System detected a new device
	DEVICE_REMOVAL_MSG				= 3001; // Device is gone
	TASK_SENDFILE                   = 4000;
	TASK_RECEIVEFILE                = 4001;
{ Own result codes }
	PVR_OK							= $00000000;
	PVR_REMOVED						= $00FFFFFF;
	PVR_ERROR_INVALIDMASK 			= $00F00001;
	PVR_ERROR_NOTIFY                = $00F00002;
	PVR_ERROR_DIRECTORY             = $00F00003;
	PVR_ERROR_NOTFDLL				= $00F00004;
{ PVR / USB - Error codes}
	{ Define the USB codes with an offset to avoid conflicts with other codes }
	PVR_ERROR_OFFSET 				= $000F0000;
	PVR_ERROR_CRC					= USB_Err_Crc + PVR_ERROR_OFFSET;
	PVR_ERROR_UNKNOWNCMD			= USB_Err_UnknownCmd + PVR_ERROR_OFFSET;
	PVR_ERROR_INVALIDCMD			= USB_Err_InvalidCmd + PVR_ERROR_OFFSET;
	PVR_ERROR_UNKNOWN				= USB_Err_Unknown + PVR_ERROR_OFFSET;
	PVR_ERROR_SIZE					= USB_Err_Size + PVR_ERROR_OFFSET;
	PVR_ERROR_RUNFAIL				= USB_Err_RunFail + PVR_ERROR_OFFSET;
	PVR_ERROR_MEMORY				= USB_Err_Memory + PVR_ERROR_OFFSET;
	PVR_ERROR_FILEOPEN		   		= USB_Err_FileOpen + PVR_ERROR_OFFSET;
	PVR_ERROR_FILECREATE			= USB_Err_FileCreate + PVR_ERROR_OFFSET;
	PVR_ERROR_FILEWRITE				= USB_Err_FileWrite + PVR_ERROR_OFFSET;
	PVR_ERROR_RECEIVE				= USB_Err_Receive + PVR_ERROR_OFFSET;
	PVR_ERROR_FILEACCESSERROR		= USB_Err_FileAccessError + PVR_ERROR_OFFSET;
	PVR_ERROR_TASKCANCEL			= USB_Err_TaskCancel + PVR_ERROR_OFFSET;
	PVR_ERROR_STBWORKERROR			= USB_Err_STBWorkError + PVR_ERROR_OFFSET;
{ PVR - Error codes}
	PVR_ERROR_FILE_NOT_FOUND 		= $00000002;
	PVR_ERROR_PATH_NOT_FOUND 		= $00000003;
	PVR_ERROR_TOO_MANY_OPEN_FILES 	= $00000004;
	PVR_ERROR_ACCESS_DENIED 		= $00000005;
	PVR_ERROR_INVALID_HANDLE 		= $00000006;
	PVR_ERROR_INVALID_PARAMETER 	= $00000057;
	PVR_ERROR_OUTOFMEMORY  			= $0000000E;
	PVR_ERROR_NEGATIVE_SEEK 		= $00000083;
	PVR_ERROR_SEEK_ON_DEVICE 		= $00000084;
	PVR_ERROR_DIR_NOT_EMPTY 		= $00000091;
	PVR_ERROR_PATH_BUSY 			= $00000094;
	PVR_ERROR_BAD_PATHNAME 			= $000000A1;
	PVR_ERROR_INVALID_NAME 			= $0000007B;
{ File attribute constants }
	tpReadOnly  					= $00000001;
	tpHidden   						= $00000002;
	tpSysFile   					= $00000004;
	tpVolumeID  					= $00000008;
	tpDirectory 					= $00000010;
	tpArchive   					= $00000020;
	tpAnyFile   					= $0000003F;
{ File open mode constants }
	tpCreate         				= $FFFF;
	tpOpenRead       				= $0000;
	tpOpenWrite      				= $0001;
	tpOpenReadWrite  				= $0002;
	tpShareCompat    				= $0000;
	tpShareExclusive 				= $0010;
	tpShareDenyWrite 				= $0020;
	tpShareDenyRead  				= $0030;
	tpShareDenyNone  				= $0040;
{ Additional constants }
	pvDriveLetter 					= '#';
	pvMaxPath 						= $0000FFFF;
{------------------------------------------------------------------------------}
{ Translated from DBT.H }
{------------------------------------------------------------------------------}
type
	_DEV_BROADCAST_HDR = record
		dbch_size: DWORD;
		dbch_devicetype: DWORD;
		dbch_reserved: DWORD;
	end;

	DEV_BROADCAST_HDR = _DEV_BROADCAST_HDR;
	PDEV_BROADCAST_HDR = ^DEV_BROADCAST_HDR;
	TDevBroadcastHdr = DEV_BROADCAST_HDR;
	PDevBroadcastHdr = PDEV_BROADCAST_HDR;

	_DEV_BROADCAST_DEVICEINTERFACE_A = record
		dbcc_size: DWORD;
		dbcc_devicetype: DWORD;
		dbcc_reserved: DWORD;
		dbcc_classguid: TGUID;
		dbcc_name: array [0..0] of char;
	end;

	DEV_BROADCAST_DEVICEINTERFACE_A = _DEV_BROADCAST_DEVICEINTERFACE_A;
	PDEV_BROADCAST_DEVICEINTERFACE_A = ^DEV_BROADCAST_DEVICEINTERFACE_A;
	TDevBroadcastDeviceInterfaceA = DEV_BROADCAST_DEVICEINTERFACE_A;
	PDevBroadcastDeviceInterfaceA = PDEV_BROADCAST_DEVICEINTERFACE_A;

	DEV_BROADCAST_DEVICEINTERFACE = DEV_BROADCAST_DEVICEINTERFACE_A;
	PDEV_BROADCAST_DEVICEINTERFACE = PDEV_BROADCAST_DEVICEINTERFACE_A;
	TDevBroadcastDeviceInterface = TDevBroadcastDeviceInterfaceA;
	PDevBroadcastDeviceInterface = PDevBroadcastDeviceInterfaceA;

{------------------------------------------------------------------------------}
{ TTopfieldReceiver types }
{------------------------------------------------------------------------------}
type
	PFileSearchInfo = ^TFileSearchInfo;
	TFileSearchInfo = record
		Mask: String;
		DirMask: String;
		ExcludeAttr: Integer;
	end;

	PFileBlock = ^TFileBlock;
	TFileBlock = record
		Data: array [0..USB_FileTypeSize - 1] of Byte;
		FirstData: PFileBlock;
		NextData: PFileBlock;
		SearchInfo: PFileSearchInfo;
	end;

	TTopfieldSearchRec = record
		Time: Integer;
		Week: Integer;
		Size: Int64;
		Attr: Integer;
		Name: String;
		ExcludeAttr: Integer;
		FindHandle: THandle;
	end;

	TTopfieldFileInfo = record
		Name: String;
		Size: Int64;
		Attr: Integer;
		Time: Integer;
		Week: Integer;
	end;

{------------------------------------------------------------------------------}
{ PVR Exception }
{------------------------------------------------------------------------------}
type
	EPvrError = class(Exception)
	private
		FErrorCode: Integer;
	public
		constructor Create(ErrCode: Integer; const Msg: String);
		destructor Destroy; override;
		property ErrorCode: Integer read FErrorCode;
	end;
{------------------------------------------------------------------------------}
{ TTopfieldReceiver }
{------------------------------------------------------------------------------}
type
	TTopfieldReceiver = class(TComponent)
	private
		// Internal use
		FTimerEventID: Cardinal;
		FTimerInterval: Cardinal;
		FNotificationStarted: Boolean;
		FBusy: TRTLCriticalSection;
		FCurDirBusy: TRTLCriticalSection;
		FFileListBusy: TRTLCriticalSection;
		FCopyBusy: TRTLCriticalSection;
		FInCopy: Boolean;
		FPvrDrive: Char;
		FCurrentDir: String;
		FFileList: TList;
		FFileHandle: Integer;
		FDllAvailable: Boolean;
		// Properties
		FHandle: HWND;
		FVendorID: Cardinal;
		FProductID: Cardinal;
		FDeviceVersion: Word;
		FActive: Boolean;
		FTurboMode: Boolean;
		FAttemptRetry: Byte;
		FFiles: Integer;
		//Events
		FOnBeforeNotifyDevice: TNotifyEvent;
		FOnTryNotifyDevice: TNotifyEvent;
		FOnAfterNotifyDevice: TNotifyEvent;
		FOnDeviceRemoved: TNotifyEvent;
		FOnBeforeCopyFile: TNotifyEvent;
		FOnAfterCopyFile: TNotifyEvent;
		FOnCopyFileFailed: TNotifyEvent;
		//Procedures / Functions
		procedure AllocateReceiverHWnd;
		procedure DeallocateReceiverHWnd;
		procedure Initialize;
		function ProcessMessage(var Msg: TMsg): Boolean;
		procedure ProcessMessages;  // Don't know if we ever will need this procedure
		procedure WMDeviceChange(var Message: TMessage); message WM_DEVICECHANGE;
		procedure WMCommand(var Message: TMessage); message WM_COMMAND;
		procedure WMTimer(var Message: TMessage); message WM_TIMER;
		procedure SetAttemptRetry(Cnt: Byte);
		function UsbToPvrError(UsbError: Cardinal): Cardinal;
		function MakeDirMask(Mask: String): String;
		function GetVidPid(var cVid, cPid: Cardinal): Boolean;
		function GetDevVersion(var DevVersion: Word): Boolean;
		function CheckCmd(pDevBuffer: PByte; DevBufferSize: Cardinal; var DevCommand, DevErrorCode: Cardinal; var pDevData: PByte; var DevDataSize: Cardinal): Boolean;
		function GetFileBlock(Path, Name: String; ExcludeAttr: Integer; var FirstBlock: PFileBlock; var PvrErrorCode: Cardinal): Boolean;
		function FindSearchRec(StartBlock: PFileBlock; var FileSearchRec: TTopfieldSearchRec; var SearchError: Cardinal): Boolean;
		procedure FreeBlock(StartBlock: PFileBlock);
		procedure FreeRecBlock(StartBlock: PFileBlock);
		function WinToPvrPath(Path: String): String;
		function PvrToWinPath(Path: String): String;
		function PathExists(Path: String): Boolean;
		function CreateDirectory(PvrPath: String; var PvrErrorCode: Cardinal): Boolean;
		function Remove(PvrPath: String; var PvrErrorCode: Cardinal): Boolean;
		procedure SetTurboMode(Mode: Boolean);
		function IsEmptyDir(PvrPath: String): Boolean;
		function ReadFileInfo(PvrPath: String; var FileInfo: TTopfieldFileinfo): Boolean;
		function ReadDataBuffer(pInfo: Pointer; Buffer: Pointer; Count: Integer; Offset: Int64; var SizeRead: Integer; var PvrErrorCode: Cardinal): Boolean;
		function ReadData(PvrPath: String; pInfo: Pointer; Buffer: Pointer; Count: Integer; var SizeRead: Integer; var PvrErrorCode: Cardinal): Boolean;
		function SendData(PvrPath: String; FileInfo:TTopfieldFileinfo; Position: Int64; Buffer: Pointer; Count: LongWord; var PvrErrorCode: Cardinal): Boolean;
		function OpenFile(PvrPath: String; Mode: LongWord): Integer;
		function GetFileListInfo(Handle: Integer; var pInfo: Pointer): Boolean;
		function Rename(PvrOldPath, PvrNewPath: String; var PvrErrorCode: Cardinal): Boolean;
		function GetDiskSizeInfo(var SizeTotal, SizeFree: LongWord; var PvrErrorCode: Cardinal): Boolean;
	protected
		procedure MainWndProc(var Message: TMessage);
		procedure WndProc(var Message: TMessage); virtual;
	public
		constructor Create(AOwner: TComponent); override;
		destructor Destroy; override;
		procedure DefaultHandler(var Message); override;
		procedure StartNotifyDevice;
		function FindFirst(const Path: string; Attr: Integer; var F: TTopfieldSearchRec): Integer;
		function FindNext(var F: TTopfieldSearchRec): Integer;
		procedure FindClose(var F: TTopfieldSearchRec);
		function GetCurrentDir: string;
		function SetCurrentDir(const Dir: string): Boolean;
		procedure GetDir(D: Byte; var S: string);
		procedure ChDir(S: string);
		function DirectoryExists(Name: string): Boolean;
		procedure MkDir(S: string);
		function CreateDir(const Dir: string): Boolean;
		procedure RmDir(S: string);
		function RemoveDir(const Dir: string): Boolean;
		function ForceDirectories(Dir: string): Boolean;
		function FileExists(const FileName: string): Boolean;
		function FileCreate(const FileName: string): Integer;
		function FileOpen(const FileName: string; Mode: LongWord): Integer;
		procedure FileClose(Handle: Integer);
		function FileSeek(Handle, Offset, Origin: Integer): Integer; overload;
		function FileSeek(Handle: Integer; const Offset: Int64; Origin: Integer): Int64; overload;
		function DeleteFile(const FileName: string): Boolean;
		function FileSearch(const Name, DirList: string): string;
		function FileAge(const FileName: string): Integer;
		function FileGetAttr(const FileName: string): Integer;
		function FileGetDate(Handle: Integer): Integer;
		function GetFileInfo(const FileName: string; var FileInfo: TTopfieldFileinfo): Boolean;
		function FileSetAttr(const FileName: string; Attr: Integer): Integer;
		function FileSetDate(Handle: Integer; Age: Integer): Integer;
		function RenameFile(const OldName, NewName: string): Boolean;
		function FileRead(Handle: Integer; var Buffer; Count: LongWord): Integer;
		function FileWrite(Handle: Integer; const Buffer; Count: LongWord): Integer;
		function GetDiskSize(var TotalSize, FreeSize: Cardinal): Boolean;
		function CopyFile(Source, Destination: String): Boolean;
		function CopyFileFromPos(Source, Destination: String; Position: Int64): Boolean;
		function CancelCopy: Boolean;
		function GetPercentage: Word;
		function PvrExpandFileName(const FileName: string): string;
		function PvrExtractFileExt(const FileName: string): string;
		function PvrExtractFileName(const FileName: string): string;
		function PvrExtractFilePath(const FileName: string): string;
		// Properties
		property Handle: HWND read FHandle;
		property VendorID: Cardinal read FVendorID;
		property ProductID: Cardinal read FProductID;
		property DeviceVersion: Word read FDeviceVersion;
		property Active: Boolean read FActive;
		property DllAvailable: Boolean read FDllAvailable;
	published
		//Events
		property OnBeforeNotifyDevice: TNotifyEvent read FOnBeforeNotifyDevice write FOnBeforeNotifyDevice;
		property OnTryNotifyDevice: TNotifyEvent read FOnTryNotifyDevice write FOnTryNotifyDevice;
		property OnAfterNotifyDevice: TNotifyEvent read FOnAfterNotifyDevice write FOnAfterNotifyDevice;
		property OnDeviceRemoved: TNotifyEvent read FOnDeviceRemoved write FOnDeviceRemoved;
		property OnBeforeCopyFile: TNotifyEvent read FOnBeforeCopyFile write FOnBeforeCopyFile;
		property OnAfterCopyFile: TNotifyEvent read FOnAfterCopyFile write FOnAfterCopyFile;
		property OnCopyFileFailed: TNotifyEvent read FOnCopyFileFailed write FOnCopyFileFailed;
		//Properties
		property AttemptRetry: Byte read FAttemptRetry write SetAttemptRetry;
		property Files: Integer read FFiles write FFiles;
		property TurboMode: Boolean read FTurboMode write SetTurboMode;
	end;
{------------------------------------------------------------------------------}
{ TTopfieldFileStream }
{------------------------------------------------------------------------------}
type
	TTopfieldFileStream = class(TStream)
	private
		FAccessTopfield: Boolean;
		FHandle: Integer;
		FTopfieldReceiver: TTopfieldReceiver;
		function GetPosition64: Int64;
		procedure SetPosition64(Pos: Int64);
		function GetSize64: Int64;
	protected
		procedure SetSize(NewSize: Longint); override;
		procedure SetSize64(NewSize: Int64);
	public
		constructor Create(TopfieldReceiver: TTopfieldReceiver; const FileName: string; Mode: Word);
		destructor Destroy; override;
		function Seek64(Offset: Int64; Origin: Word): Int64;
		function CopyFrom64(Source: TTopfieldFileStream; Count: Int64): Int64;
		function Read(var Buffer; Count: Longint): Longint; override;
		function Write(const Buffer; Count: Longint): Longint; override;
		function Seek(Offset: Longint; Origin: Word): Longint; override;
		property Position64: Int64 read GetPosition64 write SetPosition64;
		property Size64: Int64 read GetSize64 write SetSize64;
	end;

function IsTopfieldPath(const FileName: String): Boolean;
function MatchesWildCard(Source, Mask: String): Boolean;

procedure Register;

implementation

uses
	Consts;
{Internal type }
type
	PFileListInfo = ^TFileListInfo;
	TFileListInfo = record
		FileHandle: Integer;
		Name: String;
		Size: Int64;
		Attr: Integer;
		Time: Integer;
		Mode: LongWord;
		FilePointer: Int64;
		Buffer: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
		BufferSize: Integer;
		BufferPosition: Int64;
	end;
{------------------------------------------------------------------------------}
{ Global functions }
{------------------------------------------------------------------------------}
{ Check to see if pathname is a Topfield HDD pathname }
function IsTopfieldPath(const FileName: string): Boolean;
begin
	Result := ((FileName <> '') and (Pos(pvDriveLetter, FileName) = 1));
end;

{Compare two strings with wildcards (*, ?)}
function MatchesWildCard(Source, Mask: String): Boolean;
var
	SourceName, SourceExt, MaskName, MaskExt: String;
	x, iPos: Integer;

	function CompareWC(var Name, WCard: String): Boolean;
	var
		i, j, l, p: Integer;
	begin
		i := 1;
		j := 1;
		while ( i <= Length(WCard)) do
		begin
			if WCard[i] = '*' then
			begin
				if i = Length(WCard) then
				begin
					Result := True;
					Exit;
				end else
				begin
					l := i + 1;
					while (l < Length(WCard)) and (WCard[l + 1] <> '*') do
						Inc(l);
					p := Pos(Copy(WCard, i + 1, l - i), Name);
					if p > 0 then
					begin
						j := p - 1;
					end else
					begin
						Result := False;
						Exit;
					end;
				end;
			end else
			begin
				if (WCard[i] <> '?') and ((Length(Name) < i) or (WCard[i] <> Name[j])) then
				begin
					Result := False;
					Exit;
				end;
			end;
			Inc(i);
			Inc(j);
		end;
		Result := (j > Length(Name));
	end;
begin
	iPos := 0;
	for x := 1 to Length(Mask) do
	begin
		if (Mask[x] = '.') then
			iPos := x;
	end;

	if iPos = 0 then
	begin
		MaskName := Mask;
		MaskExt := '*';
	end else
	begin
		MaskName := Copy(Mask, 1, iPos - 1);
		MaskExt := Copy(Mask, iPos + 1, Length(Mask) -  iPos);
	end;

	iPos := 0;
	for x := 1 to Length(Source) do
	begin
		if (Source[x] = '.') then
			iPos := x;
	end;

	if iPos = 0 then
	begin
		SourceName := Source;
		SourceExt := '';
	end else
	begin
		SourceName := Copy(Source, 1, iPos - 1);
		SourceExt := Copy(Source, iPos + 1, Length(Source) - iPos);
	end;
	Result := CompareWC(SourceName, MaskName) and CompareWC(SourceExt, MaskExt);
end;

{------------------------------------------------------------------------------}
{ ExcludeTrailingBackslash added by jkit for Delphi4 - 04.04.2005}
{------------------------------------------------------------------------------}
{$IFDEF VER120}
function ExcludeTrailingBackslash(const PathName: string): string;
begin
  Result:=PathName;
  if (Length(Result)>1) and
     (Result[Length(Result)]='\') and
	 ((Length(Result)<>3) or (Result[2]<>':')) then SetLength(Result,Length(Result)-1);
end;
{$ENDIF}

{------------------------------------------------------------------------------}
{ EPvrError }
{------------------------------------------------------------------------------}
{Constructor }
constructor EPvrError.Create(ErrCode: Integer; const Msg: String);
begin
  FErrorCode := ErrCode;
  inherited Create(Msg);
end;

{ Destructor }
destructor EPvrError.Destroy;
begin
	 inherited Destroy;
end;
{------------------------------------------------------------------------------}
{TTopfieldReceiver}
{------------------------------------------------------------------------------}
{ Constructor }
constructor TTopfieldReceiver.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);
	// Init properties
	FHandle := 0;
	FVendorID := 0;
	FProductID := 0;
	FDeviceVersion := 0;
	FTimerEventID := 0;
	FTimerInterval := 1000;
	FActive := False;
	FTurboMode := False;
	FAttemptRetry := 3;
	FPvrDrive := pvDriveLetter; // Set drive letter
	FCurrentDir := '\';
	FNotificationStarted := False;
	FFiles := -1;
	FFileHandle := 0;
	FInCopy := False;
	FDllAvailable := TFDllLoaded;
	if not (csDesigning in ComponentState) then
	begin
		AllocateReceiverHWnd; // Get a window handle for messages
		Initialize; // Initalize DLL
		// Generate critical sections
		InitializeCriticalSection(FBusy);
		InitializeCriticalSection(FCurDirBusy);
		InitializeCriticalSection(FFileListBusy);
		InitializeCriticalSection(FCopyBusy);
		FFileList := TList.Create;
	end;
end;

{ Destructor }
destructor TTopfieldReceiver.Destroy;
begin
	if not (csDesigning in ComponentState) then
	begin
		// Kill the timer if assigned
		if (FTimerEventID <> 0) then
		begin
			KillTimer(FHandle, FTimerEventID);
			FTimerEventID := 0;
		end;
		FFileList.Free;
		FFileList := Nil;
		// Delete critical sections
		DeleteCriticalSection(FCopyBusy);
		DeleteCriticalSection(FFileListBusy);
		DeleteCriticalSection(FCurDirBusy);
		DeleteCriticalSection(FBusy);
		// Free window handle
		DeallocateReceiverHWnd;
	end;
	inherited Destroy;
end;
{------------------------------------------------------------------------------}
{ Private procedures and function}
{------------------------------------------------------------------------------}
{ Allocates a window handle }
procedure TTopfieldReceiver.AllocateReceiverHWnd;
begin
	if FHandle = 0 then
		FHandle := AllocateHWnd(MainWndProc);
end;

{ Deallocates a window handle }
procedure TTopfieldReceiver.DeallocateReceiverHWnd;
begin
	if FHandle <> 0 then
		DeallocateHWnd(FHandle);
	FHandle := 0;
end;

{Initializes tfdll }
procedure TTopfieldReceiver.Initialize;
begin
	if FDllAvailable then
		InitDevice;
end;

{ Process windows messages }
function TTopfieldReceiver.ProcessMessage(var Msg: TMsg): Boolean;
begin
	Result := False;
	if PeekMessage(Msg, FHandle, 0, 0, PM_REMOVE) then
	begin
		Result := True;
		TranslateMessage(Msg);
		DispatchMessage(Msg);
	end;
end;

{ Message loop }
procedure TTopfieldReceiver.ProcessMessages;
var
	Msg: TMsg;
begin
	while ProcessMessage(Msg) do;
end;

{ Messages hanlder for device arrival and remove }
procedure TTopfieldReceiver.WMDeviceChange(var Message: TMessage);
var
	pdbcd: PDevBroadcastDeviceInterface;
	pdbch: PDevBroadcastHdr;
begin
	case Message.Msg of
		WM_DEVICECHANGE:
			begin
				pdbch := PDevBroadcastHdr(Message.LParam);
				if Assigned(pdbch) then
				begin
					case pdbch^.dbch_devicetype of
						DBT_DEVTYP_DEVICEINTERFACE:
							begin
								pdbcd := PDevBroadcastDeviceInterface(Message.LParam);
								case Message.WParam of
									DBT_DEVICEARRIVAL:
										begin
											if (DeviceArrival(pdbcd^.dbcc_name)) then
											begin
												SendMessage(FHandle, WM_COMMAND, wParam(DEVICE_ARRIVAL_MSG), 0);
											end;
											Message.Result := 1;
											Exit;
										end;
									DBT_DEVICEREMOVECOMPLETE:
										begin
											SendMessage(FHandle, WM_COMMAND, wParam(DEVICE_REMOVAL_MSG), 0);
											DeviceRemoval(pdbcd^.dbcc_name);
											Message.Result := 1;
											Exit;
										end;
								end;
							end;
					end;
				end;
			end;
	end;
	inherited;
end;

{ Command message handler }
procedure TTopfieldReceiver.WMCommand(var Message: TMessage);
begin
	case Message.WParamLo of
		// Device arrived
		DEVICE_ARRIVAL_MSG:
			begin
				FActive := True; // Set state to active
				// Kill the timer if assigned
				if (FTimerEventID <> 0) then
				begin
					KillTimer(FHandle, FTimerEventID);
					FTimerEventID := 0;
				end;
				// Get Vid / pid and device version
				if (GetVidPid(FVendorID, FProductID) = False) or (GetDevVersion(FDeviceVersion) = False) then
				begin
					FVendorID := 0;
					FProductID := 0;
					FDeviceVersion := 0;
					FInCopy := False;
					raise EPvrError.Create(PVR_REMOVED, 'Can not connect to Receiver.');
				end;
				SetTurboMode(FTurboMode);
				Message.Result := 1;
				if Assigned(FOnAfterNotifyDevice) then FOnAfterNotifyDevice(Self);
				Exit;
			end;
		// Device is removed
		DEVICE_REMOVAL_MSG:
			begin
				FActive := False;
				FVendorID := 0;
				FProductID := 0;
				FDeviceVersion := 0;
				FInCopy := False;
				if Assigned(FOnDeviceRemoved) then FOnDeviceRemoved(Self);
				// Kill timer if assigned
				if (FTimerEventID = 0) then begin
					FTimerEventID := 1;
					if SetTimer(FHandle, FTimerEventID, FTimerInterval, nil) = 0 then
					begin
						FTimerEventID := 0;
						raise EOutOfResources.Create(SNoTimers);
					end;
				end;
				Message.Result := 1;
				Exit;
			end;
		TASK_SENDFILE, TASK_RECEIVEFILE:
			begin
				if (FInCopy = True) then
				begin
					FInCopy := False;
					LeaveCriticalSection(FCurDirBusy);
					LeaveCriticalSection(FFileListBusy);
					LeaveCriticalSection(FBusy);
					LeaveCriticalSection(FCopyBusy);
					if Message.LParam = 1 then
					begin
						if Assigned(FOnAfterCopyFile) then FOnAfterCopyFile(Self);
					end else
					begin
						if Assigned(FOnCopyFileFailed) then FOnCopyFileFailed(Self);
					end;
					Message.Result := 1;
					Exit;
				end;
			end;
	end;
	inherited;
end;

{ Try to open device periodically }
procedure TTopfieldReceiver.WMTimer(var Message: TMessage);
begin
	if (Cardinal(Message.WParam) = FTimerEventID) then
	begin
		if (TryDeviceOpen) then
		begin
			if DeviceArrival(Nil) then
			begin
				SendMessage(FHandle, WM_COMMAND, wParam(DEVICE_ARRIVAL_MSG), 0);
			end;
		end;
		Message.Result := 0;
		Exit;
	end;
	inherited;
end;

{ Set retry }
procedure TTopfieldReceiver.SetAttemptRetry(Cnt: Byte);
begin
	try
		if not (csDesigning in ComponentState) then EnterCriticalSection(FBusy);
		FAttemptRetry := Cnt;
	finally
		if not (csDesigning in ComponentState) then LeaveCriticalSection(FBusy);
	end;
end;

{ Converts USB Error as defined in tfdll.pas to PVR errorcode }
function TTopfieldReceiver.UsbToPvrError(UsbError: Cardinal): Cardinal;
begin
	if (UsbError <> PVR_OK) then
		Result := UsbError + PVR_ERROR_OFFSET
	else
		Result := PVR_OK;
end;

{ Creates a directory mask }
function TTopfieldReceiver.MakeDirMask(Mask: String): String;
var
	Ext: String;
	i: Integer;
	OnlyWC: Boolean;
begin
	Result := Mask;
	Ext := PvrExtractFileExt(Mask);
	OnlyWC := True;
	for i := 2 to Length(Ext) do
		if (Ext[i] <> '*') and (Ext[i] <> '?') then
			OnlyWC := False;
	if OnlyWC then
		Result := Copy(Mask, 1, Length(Mask) - Length(Ext));
end;

{ Get Vid / Pid from device }
function TTopfieldReceiver.GetVidPid(var cVid, cPid: Cardinal): Boolean;
var
	vid, pid: DWORD;
	iRetry: Integer;
	bSuccess: BOOL;
begin
	Result := False;
	cVid := 0;
	cPid := 0;
	iRetry := Integer(FAttemptRetry);
	bSuccess := False;
	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
			begin
				bSuccess := GetDeviceVidPid(@vid,@pid);
				if (bSuccess) then
				begin
					cVid := vid;
					cPid := pid;
					Result := True;
				end else
					Dec(iRetry);
			end;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end;
end;

{ Get device version }
function TTopfieldReceiver.GetDevVersion(var DevVersion: Word): Boolean;
var
	DevVer: Word;
	iRetry: Integer;
	bSuccess: BOOL;
begin
	Result := False;
	DevVersion := 0;
	iRetry := Integer(FAttemptRetry);
	bSuccess := False;
	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
			begin
				bSuccess := GetDeviceVersion(@DevVer);
				if (bSuccess) then
				begin
					DevVersion := DevVer;
					Result := True;
				end else
					Dec(iRetry);
			end;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end;
end;

{ Check USB command }
function TTopfieldReceiver.CheckCmd(pDevBuffer: PByte; DevBufferSize: Cardinal; var DevCommand, DevErrorCode: Cardinal; var pDevData: PByte; var DevDataSize: Cardinal): Boolean;
var
	BlockLength, BlockCrc16, DataCrc16: Word;
begin
	if ((not Assigned(pDevBuffer)) or (DevBufferSize = 0)) then
	begin
		DevCommand := USB_CmdNone;
		DevErrorCode := USB_Err_Unknown;
		Result := False;
		Exit;
	end;

	DevCommand := USB_CmdNone;
	DevErrorCode := USB_OK;

	BlockLength := Get16bit(pDevBuffer);

	if ((BlockLength > DevBufferSize) or (BlockLength < 8)) then
	begin
		DevErrorCode := USB_Err_Size;
		Result := False;
		Exit;
	end;
	Inc(pDevBuffer, 2);
	BlockCrc16 := Get16bit(pDevBuffer);
	Inc(pDevBuffer, 2);
	DataCrc16 := GetCrc16(pDevBuffer, BlockLength - 4);

	if (BlockCrc16 <> DataCrc16) then
	begin
		DevErrorCode := USB_Err_Crc;
		Result := False;
		Exit;
	end;
	DevCommand := Get32bit(pDevBuffer);
	Inc(pDevBuffer, 4);
	pDevData := pDevBuffer;
	DevDataSize := Cardinal(BlockLength - 8);
	Result := True;
end;

{ Read directory from device and assign it to a PFileBlock structure }
function TTopfieldReceiver.GetFileBlock(Path, Name: String; ExcludeAttr: Integer; var FirstBlock: PFileBlock; var PvrErrorCode: Cardinal): Boolean;
var
	SearchPath: PChar;
	SizeSearchPath, MsgSize, DevCmd, DevError, DevDataSize, i, j: Cardinal;
	pBuffer, pData: PByte;
	pBlock, PrevBlock: PFileBlock;
	MsgBuf: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
	bSuccess: BOOL;
	pSearchInfo: PFileSearchInfo;
begin
	Result := False;
	PvrErrorCode := PVR_REMOVED;
	FirstBlock := Nil;
	PrevBlock := Nil;
	pSearchInfo := Nil;
	SizeSearchPath := Length(Path);
	SearchPath := PChar(Path);
	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			bSuccess := UsbCommandSend(USB_CmdHddDir, PByte(SearchPath), SizeSearchPath + 1);
			if (bSuccess = True) then
			begin
				if not Assigned(pSearchInfo) then
				begin
					New(pSearchInfo);
					pSearchinfo^.Mask := Name;
					pSearchinfo^.DirMask := MakeDirMask(Name);
					pSearchInfo^.ExcludeAttr := ExcludeAttr;
				end;
				repeat
					FillChar(MsgBuf, MAX_UsbBlockSize + $1000, #0); // Reset buffer
					pBuffer := @MsgBuf[0];
					MsgSize := UsbRead(pBuffer, MAX_UsbBlockSize);
					bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
					if (bSuccess = True) then
					begin
						if (DevCmd = USB_DataHddDir) then
						begin
							i := 0;
							while (i < DevDataSize) do
							begin
								New(pBlock);
								if not Assigned(PrevBlock) then
									FirstBlock := pBlock
								else
									PrevBlock^.NextData := pBlock;
								pBlock^.FirstData := FirstBlock;
								pBlock^.NextData := Nil;
								pBlock^.SearchInfo := pSearchInfo;
								PrevBlock := pBlock;
								for j := 0 to USB_FileTypeSize - 1 do
								begin
									pBlock^.Data[j] := pData^;
									Inc(i);
									if (i < DevDataSize) then Inc(pData);
								end;
							end;
							bSuccess := UsbCommandSend(USB_Success, Nil, 0);
						end else if (DevCmd = USB_DataHddDirEnd) then
						begin
							PvrErrorCode := PVR_OK;
						end else
						begin
							DevError := USB_Err_InvalidCmd;
							bSuccess := False;
						end;
					end else
					begin
						bSuccess := False;
					end;
				until (PvrErrorCode = PVR_OK) or (bSuccess = False);

				if (not bSuccess) and (Assigned(pSearchInfo)) then
					Dispose(pSearchInfo);

				if (PvrErrorCode = PVR_OK) then
					Result := True
				else if (FActive = False) then
					PvrErrorCode := PVR_REMOVED
				else if (DevError > USB_OK) then
					PvrErrorCode := UsbToPvrError(DevError)
				else
					PvrErrorCode := PVR_ERROR_UNKNOWN;
			end else
				if (FActive = False) then
					PvrErrorCode := PVR_REMOVED
				else
					PvrErrorCode := PVR_ERROR_UNKNOWN;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end;
end;

{ Split PFileBlock to FileSearchRec }
function TTopfieldReceiver.FindSearchRec(StartBlock: PFileBlock; var FileSearchRec: TTopfieldSearchRec; var SearchError: Cardinal): Boolean;
var
	BlockFileName: array[0..USB_FileNameSize] of char;
	pBlock: PFileBlock;
	pFileName: PChar;
	i: Cardinal;
	Name, Mask: String;
	Attr: Integer;
	IsMatching: Boolean;
	MJD, Year, Hour, Min, Sec: Word;
	Month, Day, Week: Byte;
	FileTime, FileDate: TDateTime;
	Size: Int64;
begin
	Result := False;
	SearchError := PVR_ERROR_FILE_NOT_FOUND;
	IsMatching := False;
	pBlock := StartBlock;
	while (Assigned(pBlock) and not IsMatching) do
	begin
		i := 0;
		while ((i < USB_FileNameSize - 1) and (Char(pBlock^.Data[i + 14]) <> #0)) do
		begin
			BlockFileName[i] := Char(pBlock^.Data[i + 14]);
			Inc(i);
		end;
		BlockFileName[i] := #0;
		pFileName := @BlockFileName[0];
		Name := pFileName;
		Attr := Get32Bit(@pBlock^.Data[110]);
		Attr := Attr shr 24;
		Mask := pBlock^.SearchInfo^.Mask;

		if (Integer(pBlock^.Data[5]) = 1) then
		begin
			Attr := Attr or tpDirectory;
			Mask := pBlock^.SearchInfo^.DirMask;
		end;

		if (Name = '..') then
		begin
			Attr := tpDirectory;
			Mask := pBlock^.SearchInfo^.DirMask;
		end;

		try
			IsMatching := MatchesWildCard(Name, Mask);
		except
			SearchError := PVR_ERROR_INVALIDMASK;
			Exit;
		end;

		if ((IsMatching = False) or (Attr and pBlock^.SearchInfo^.ExcludeAttr <> 0)) then
		begin
			IsMatching := False;
			pBlock := pBlock^.NextData;
		end else begin
			if (Name = '..') then
			begin
				Week := 0;
				FileDate := Now;
				Size := 0;
			end else
			begin
				MJD := Get16bit(@pBlock^.Data[0]);
				Hour := Word(pBlock^.Data[2]);
				Min := Word(pBlock^.Data[3]);
				Sec :=  Word(pBlock^.Data[4]);
				Size := Int64(Get32Bit(@pBlock^.Data[6]));
				Size := Size shl 32;
				Size := Size or Int64(Get32Bit(@pBlock^.Data[10]));

				ExtractMjd(MJD, @Year, @Month, @Day, @Week);
				FileDate := EncodeDate(Year, Word(Month), Word(Day));
				FileTime := EncodeTime(Hour, Min, Sec, 0);
				{ added by jkit for Delphi4 - 04.04.2005}
				{$IFDEF VER120}
				FileDate := FileDate + FileTime;
				{$ELSE}
				ReplaceTime(FileDate, FileTime);
				{$ENDIF}
			end;
			FileSearchRec.Name := Name;
			FileSearchRec.Attr := Attr;
			FileSearchRec.FindHandle := THandle(pBlock);
			FileSearchRec.Week := Integer(Week) + 1;
			FileSearchRec.Time := DateTimeToFileDate(FileDate);
			FileSearchRec.ExcludeAttr := pBlock^.SearchInfo^.ExcludeAttr;
			FileSearchRec.Size := Size;
			SearchError := PVR_OK;
			Result := True;
		end;
	end;
end;

{ Free PFileBlock structure }
procedure TTopfieldReceiver.FreeBlock(StartBlock: PFileBlock);
var
	pBlock, NextBlock: PFileBlock;
begin
	NextBlock := StartBlock;
	while Assigned(NextBlock) do
	begin
		pBlock := NextBlock;
		NextBlock := pBlock^.NextData;
		Dispose(pBlock);
	end;
end;

{ Free PFileBlock and PFileSearchInfo }
procedure TTopfieldReceiver.FreeRecBlock(StartBlock: PFileBlock);
var
	pSearchInfo: PFileSearchInfo;
begin
	if Assigned(StartBlock) then
	begin
		pSearchInfo := StartBlock^.SearchInfo;
		if Assigned(pSearchInfo) then
			Dispose(pSearchInfo);
		FreeBlock(StartBlock);
	end;
end;

{ Convert Windows path style to PVR path style }
function TTopfieldReceiver.WinToPvrPath(Path: String): String;
var
	PvrPath: String;
begin
	if (Length(Path) > 1) and (Path[1] = FPvrDrive) and (Path[2] = ':') then
		PvrPath := Copy(Path, 3, Length(Path) - 2)
	else
		PvrPath := Path;
	Result := PvrExpandFileName(PvrPath);
end;

{ Convert PVR path style to Windows path style }
function TTopfieldReceiver.PvrToWinPath(Path: String): String;
begin
	Result := FPvrDrive + ':' + Path;
end;

{ Checks if path exists on PVR }
function TTopfieldReceiver.PathExists(Path: String): Boolean;
var
	SearchRec: TTopfieldSearchRec;
begin
	Result := False;
	if (Path = '\') then
		Result := True
	else
	begin
		if FindFirst(Path, tpAnyFile, SearchRec) = 0 then
		begin
			repeat
				if SearchRec.Attr and tpDirectory <> 0 then Result := True;
			until (FindNext(SearchRec) <> 0) or (Result = True);
		end;
		FindClose(SearchRec);
	end;
end;

{ Create a directory on PVR }
function TTopfieldReceiver.CreateDirectory(PvrPath: String; var PvrErrorCode: Cardinal): Boolean;
var
	SizePath, MsgSize, DevCmd, DevError, DevDataSize, h: Cardinal;
	pBuffer, pData: PByte;
	MsgBuf: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
	bSuccess: BOOL;
begin
	Result := False;
	PvrErrorCode := PVR_REMOVED;
	SizePath := Length(PvrPath);
	if (SizePath > pvMaxPath) then
	begin
		PvrErrorCode := PVR_ERROR_BAD_PATHNAME;
		Exit;
	end;
	Put16bit(@MsgBuf[0], SizePath + 1);
	for h := 2 to SizePath + 1 do
		MsgBuf[h] := Ord(PvrPath[h - 1]);
	MsgBuf[SizePath + 2] := 0;
	pBuffer := @MsgBuf[0];
	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			bSuccess := UsbCommandSend(USB_CmdHddCreateDir, pBuffer, SizePath + 1 + 2);
			if (bSuccess = True) then
			begin
				FillChar(MsgBuf, MAX_UsbBlockSize + $1000, #0); // Reset buffer
				pBuffer := @MsgBuf[0];
				MsgSize := UsbRead(pBuffer, 16);
				bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
				if (bSuccess = True) then
				begin
					if (DevCmd = USB_Success) then
					begin
						PvrErrorCode := PVR_OK;
						Result := True;
					end else
					begin
						DevError := USB_Err_InvalidCmd;
						bSuccess := False;
					end;
				end;
				if not bSuccess then
				begin
					if (FActive = False) then
						PvrErrorCode := PVR_REMOVED
					else
						UsbToPvrError(DevError);
				end;
			end else
			begin
				if (FActive = False) then
					PvrErrorCode := PVR_REMOVED
				else
					PvrErrorCode := PVR_ERROR_UNKNOWN;
			end;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end;
end;

{ Remove path from PVR }
function TTopfieldReceiver.Remove(PvrPath: String; var PvrErrorCode: Cardinal): Boolean;
var
	Path: PChar;
	SizePath, MsgSize, DevCmd, DevError, DevDataSize: Cardinal;
	pBuffer, pData: PByte;
	MsgBuf: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
	bSuccess: BOOL;
begin
	Result := False;
	PvrErrorCode := PVR_REMOVED;
	SizePath := Length(PvrPath);
	Path := PChar(PvrPath);

	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			bSuccess := UsbCommandSend(USB_CmdHddDel, PByte(Path), SizePath + 1);
			if (bSuccess = True) then
			begin
				FillChar(MsgBuf, MAX_UsbBlockSize + $1000, #0); // Reset buffer
				pBuffer := @MsgBuf[0];
				MsgSize := UsbRead(pBuffer, 16);
				bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
				if (bSuccess = True) then
				begin
					if (DevCmd = USB_Success) then
					begin
						PvrErrorCode := PVR_OK;
						Result := True;
					end else
					begin
						DevError := USB_Err_InvalidCmd;
						bSuccess := False;
					end;
				end;
				if not bSuccess then
				begin
					if (FActive = False) then
						PvrErrorCode := PVR_REMOVED
					else
						UsbToPvrError(DevError);
				end;
			end else
			begin
				if (FActive = False) then
					PvrErrorCode := PVR_REMOVED
				else
					PvrErrorCode := PVR_ERROR_UNKNOWN;
			end;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end;
end;

{ Set turbo mode }
procedure TTopfieldReceiver.SetTurboMode(Mode: Boolean);
var
	MsgSize, DevCmd, DevError, DevDataSize: Cardinal;
	pBuffer, pData: PByte;
	MsgBuf: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
	bSuccess: BOOL;
begin
	MsgBuf[0] := 0;
	MsgBuf[1] := 0;
	MsgBuf[2] := 0;
	if (Mode = False) then
		MsgBuf[3] := 0
	else
		MsgBuf[3] := 1;

	pBuffer := @MsgBuf[0];
	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			bSuccess := UsbCommandSend(USB_CmdTurbo, pBuffer, 4);
			if (bSuccess = True) then
			begin
				FillChar(MsgBuf, MAX_UsbBlockSize + $1000, #0); // Reset buffer
				pBuffer := @MsgBuf[0];
				MsgSize := UsbRead(pBuffer, 16);
				bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
				if ((bSuccess = True) and (DevCmd = USB_Success)) then
				begin					
					FTurboMode := Mode;
				end;
			end;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end else
	begin
		FTurboMode := Mode;
	end;
end;

{ Check if directory is empty }
function TTopfieldReceiver.IsEmptyDir(PvrPath: String): Boolean;
var
	SearchRec: TTopfieldSearchRec;
begin
	Result := True;

	if (PvrPath <> '\') then
	begin
		PvrPath := ExcludeTrailingBackslash(PvrPath);
		PvrPath := PvrPath + '\*.*';
	end else
		PvrPath := PvrPath + '*.*';

	if FindFirst(PvrPath, tpAnyFile, SearchRec) = 0 then
	begin
		repeat
			if not ((SearchRec.Attr = tpDirectory) and (SearchRec.Name = '..')) then
				Result := False;
		until (Result = False) or (FindNext(SearchRec) <> 0);
	end;
	FindClose(SearchRec);
end;

{ Get file info from PVR }
function TTopfieldReceiver.ReadFileInfo(PvrPath: String; var FileInfo: TTopfieldFileinfo): Boolean;
var
	SearchRec: TTopfieldSearchRec;
begin
	Result := False;
	FileInfo.Name := '';
	FileInfo.Size := 0;
	FileInfo.Attr := 0;
	FileInfo.Time := 0;
	FileInfo.Week := 0;
	if FindFirst(PvrPath, tpAnyFile, SearchRec) = 0 then
	begin
		repeat
			if not(SearchRec.Attr and tpDirectory <> 0) then
			begin
				FileInfo.Name := SearchRec.Name;
				FileInfo.Size := SearchRec.Size;
				FileInfo.Attr := SearchRec.Attr;
				FileInfo.Time := SearchRec.Time;
				FileInfo.Week := SearchRec.Week;
				Result := True;
			end;
		until (Result = True) or (FindNext(SearchRec) <> 0);
	end;
	FindClose(SearchRec);
end;

{ Read file data into buffer }
function TTopfieldReceiver.ReadDataBuffer(pInfo: Pointer; Buffer: Pointer; Count: Integer; Offset: Int64; var SizeRead: Integer; var PvrErrorCode: Cardinal): Boolean;
var
	MsgSize, DevCmd, DevError, DevDataSize: Cardinal;
	BufferCount: Integer;
	FileListInfo: PFileListInfo;
	pBuffer, pData: PByte;
	bSuccess: Boolean;
	MsgBuf: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
begin
	Result := False;
	BufferCount := Count;
	SizeRead := 0;
	PvrErrorCode := PVR_REMOVED;
	FileListInfo := PFileListInfo(pInfo);

	while True do
	begin
		pBuffer := @MsgBuf[0];
		MsgSize := UsbRead(pBuffer, MAX_UsbBlockSize);
		bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
		if (bSuccess = True) then
		begin
			if (DevCmd = USB_DataHddFileData) then
			begin
				if (DevDataSize > 8) then
				begin
					FileListInfo^.BufferSize := DevDataSize - 8 - Cardinal(Offset);
					FileListInfo^.BufferPosition := Int64(Get32Bit(pData));
					FileListInfo^.BufferPosition := FileListInfo^.BufferPosition shl 32;
					Inc(pData, 4);
					FileListInfo^.BufferPosition := FileListInfo^.BufferPosition or Int64(Get32Bit(pData));
					FileListInfo^.BufferPosition := FileListInfo^.BufferPosition + Offset;
					Inc(pData, 4);
					if (Offset > 0) then
					begin
						Inc(pData, Offset);
						Offset := 0;
					end;
					Move(pData^, FileListInfo^.Buffer[0], FileListInfo^.BufferSize);

					if (FileListInfo^.BufferSize >= BufferCount) then
					begin
						Move(FileListInfo^.Buffer[0], Pointer(Integer(Buffer) + SizeRead)^, BufferCount);
						SizeRead := SizeRead + BufferCount;
						FileListInfo^.FilePointer := FileListInfo^.FilePointer + Int64(BufferCount);
						BufferCount := 0;
					end else
					begin
						Move(FileListInfo^.Buffer[0], Pointer(Integer(Buffer) + SizeRead)^, FileListInfo^.BufferSize);
						SizeRead := SizeRead + FileListInfo^.BufferSize;
						BufferCount := BufferCount - FileListInfo^.BufferSize;
						FileListInfo^.FilePointer := FileListInfo^.FilePointer + Int64(FileListInfo^.BufferSize);
					end;

					if (BufferCount = 0) then
					begin
						bSuccess := UsbCommandSend(USB_Cancel, Nil, 0);
						if (bSuccess = True) then
							UsbRead(pBuffer, MAX_UsbBlockSize);
						PvrErrorCode := PVR_OK;
						Result := True;
						break;
					end else
						UsbCommandSend(USB_Success, Nil, 0);
				end else
				begin
					if (FActive = True) then
					begin
						Put32Bit(@MsgBuf[0], USB_Err_Size);
						pBuffer := @MsgBuf[0];
						UsbCommandSend(USB_Fail, pBuffer, 4);
						PvrErrorCode := PVR_ERROR_SIZE;
					end;
					break;
				end;
			end else if (DevCmd = USB_DataHddFileEnd) then
			begin
				UsbCommandSend(USB_Success, Nil, 0);
				PvrErrorCode := PVR_OK;
				Result := True;
				break;
			end else
			begin
				if (FActive = True) then
				begin
					PvrErrorCode := PVR_ERROR_UNKNOWN;
				end;
				break;
			end;
		end else
		begin
			if (FActive = True) then
			begin
				PvrErrorCode := UsbToPvrError(DevError);
			end;
			break;
		end;
	end;
end;

{ Reads data from PVR }
function TTopfieldReceiver.ReadData(PvrPath: String; pInfo: Pointer; Buffer: Pointer; Count: Integer; var SizeRead: Integer; var PvrErrorCode: Cardinal): Boolean;
var
	SizePath, MsgSize, MSB, LSB, DevCmd, DevError, DevDataSize, h: Cardinal;
	MsgBuf: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
	pBuffer, pData: PByte;
	bSuccess: Boolean;

	Position, Offset, iBlock: Int64;
	FileListInfo: PFileListInfo;
begin
	Result := False;
	PvrErrorCode := PVR_REMOVED;
	SizeRead := 0;
	FileListInfo := PFileListInfo(pInfo);
	Position := FileListInfo^.FilePointer;
	// Need to read in 512 Byte blocks. Maybe there is a bug in the API.
	Offset := 0;
	iBlock := 512;
	if (Position <> 0) then
	begin
		Offset := Position mod iBlock;
		Position := Position div iBlock;
		Position := Position * iBlock;
	end;
	SizePath := Length(PvrPath);
	MsgBuf[0] := 1;
	Put16Bit(@MsgBuf[1], SizePath + 1);
	for h := 1 to SizePath do
		MsgBuf[h + 2] := Ord(PvrPath[h]);
	MsgBuf[SizePath + 1 + 2] := 0;
	MSB := Cardinal(Position shr 32);
	LSB := Cardinal(Position);
	Put32Bit(@MsgBuf[SizePath + 4], MSB);
	Put32Bit(@MsgBuf[SizePath + 8], LSB);
	pBuffer := @MsgBuf[0];
	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			bSuccess := UsbCommandSend(USB_CmdHddFileSend, pBuffer, SizePath + 1 + 11);
			if (bSuccess = True) then
			begin
				pBuffer := @MsgBuf[0];
				MsgSize := UsbRead(pBuffer, MAX_UsbBlockSize);
				bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
				if (bSuccess = True) then
				begin
					if (DevCmd = USB_DataHddFileStart) then
					begin
						if (DevDataSize = USB_FileTypeSize) then
						begin
							bSuccess := UsbCommandSend(USB_Success, Nil, 0);
							if (bSuccess = True) then
								Result := ReadDataBuffer(pInfo, Buffer, Count, Offset, SizeRead, PvrErrorCode)
							else if (FActive = True) then
								PvrErrorCode := PVR_ERROR_UNKNOWN;
						end else
						begin
							if (FActive = True) then
							begin
								Put32Bit(@MsgBuf[0], USB_Err_Size);
								pBuffer := @MsgBuf[0];
								UsbCommandSend(USB_Fail, pBuffer, 4);
								PvrErrorCode := PVR_ERROR_SIZE;
							end;
						end;
					end else
					begin
						if (FActive = True) then
						begin
							PvrErrorCode := PVR_ERROR_UNKNOWN;
						end;
					end;
				end else
				begin
					if (FActive = True) then
					begin
						PvrErrorCode := UsbToPvrError(DevError);
					end;
				end;
			end else if (FActive = True) then
				PvrErrorCode := PVR_ERROR_UNKNOWN;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end;
end;

{ Send file data to PVR }
function TTopfieldReceiver.SendData(PvrPath: String; FileInfo:TTopfieldFileinfo; Position: Int64; Buffer: Pointer; Count: LongWord; var PvrErrorCode: Cardinal): Boolean;
var
	SizePath, MsgSize, MSB, LSB, DevCmd, DevError, DevDataSize, h, BlockLen, BlockCount, SizeWrite: Cardinal;
	MsgBuf: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
	pBuffer, pData: PByte;
	MJD, Year, Month, Day, Hour, Min, Sec, MSec: Word;
	bMonth, bDay: byte;
	FileDate: TDateTime;
	bSuccess: Boolean;
	StartPosition: Int64;
begin
	Result := False;
	PvrErrorCode := PVR_REMOVED;
	SizePath := Length(PvrPath);
	MsgBuf[0] := 0;
	Put16Bit(@MsgBuf[1], SizePath + 1);
	for h := 1 to SizePath do
		MsgBuf[h + 2] := Ord(PvrPath[h]);
	MsgBuf[SizePath + 1 + 2] := 0;
	MSB := Cardinal(Position shr 32);
	LSB := Cardinal(Position);
	Put32Bit(@MsgBuf[SizePath + 4], MSB);
	Put32Bit(@MsgBuf[SizePath + 8], LSB);
	pBuffer := @MsgBuf[0];
	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			bSuccess := UsbCommandSend(USB_CmdHddFileSend, pBuffer, SizePath + 1 + 11);
			if (bSuccess = True) then
			begin
				pBuffer := @MsgBuf[0];
				MsgSize := UsbRead(pBuffer, MAX_UsbBlockSize);
				bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
				if (bSuccess = True) then
				begin
					if (DevCmd = USB_Success) then
					begin
						FileDate := FileDateToDateTime(FileInfo.Time);
						DecodeDate(FileDate, Year, Month, Day);
						DecodeTime(FileDate, Hour, Min, Sec, MSec);
						bMonth := Byte(Month);
						bDay := Byte(Day);
						MJD := MakeMjd(Year, bMonth, bDay);
						Put16Bit(@MsgBuf[0], MJD);
						MsgBuf[2] := Byte(Hour);
						MsgBuf[3] := Byte(Min);
						MsgBuf[4] := Byte(Sec);
						MsgBuf[5] := 2;
						MSB := Cardinal(FileInfo.Size shr 32);
						LSB := Cardinal(FileInfo.Size);
						Put32Bit(@MsgBuf[6], MSB);
						Put32Bit(@MsgBuf[10], LSB);
						for h := 1 to Length(FileInfo.Name) do
							MsgBuf[h + 13] := Ord(Fileinfo.Name[h]);
						MsgBuf[Length(FileInfo.Name) + 13 + 1] := 0;
						MsgBuf[109] := 0;
						Put32Bit(@MsgBuf[110], FileInfo.Attr);
						pBuffer := @MsgBuf[0];
						bSuccess := UsbCommandSend(USB_DataHddFileStart, pBuffer, USB_FileTypeSize);
						if (bSuccess = True) then
						begin
							pBuffer := @MsgBuf[0];
							MsgSize := UsbRead(pBuffer, MAX_UsbBlockSize);
							bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
							if (bSuccess = True) then
							begin
								if (DevCmd = USB_Success) then
								begin
									if Assigned(Buffer) then
									begin
										BlockLen :=  Count;
										StartPosition := Position;
										SizeWrite := 0;
										while (BlockLen > 0) do
										begin
											if (BlockLen > MAX_UsbFileDataSize) then
											begin
												BlockCount := MAX_UsbFileDataSize;
												BlockLen := BlockLen - MAX_UsbFileDataSize;
											end else
											begin
												BlockCount := BlockLen;
												BlockLen := 0;
											end;

											Move(Pointer(Cardinal(Buffer) + SizeWrite)^, MsgBuf[8], BlockCount);
											SizeWrite := SizeWrite + BlockCount;
											MSB := Cardinal(StartPosition shr 32);
											LSB := Cardinal(StartPosition);
											StartPosition := StartPosition + BlockCount;
											Put32Bit(@MsgBuf[0], MSB);
											Put32Bit(@MsgBuf[4], LSB);
											pBuffer := @MsgBuf[0];
											bSuccess := UsbCommandSend(USB_DataHddFileData, pBuffer, BlockCount + 8);
											if (bSuccess = True) then
											begin
												pBuffer := @MsgBuf[0];
												MsgSize := UsbRead(pBuffer, MAX_UsbBlockSize);
												bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
												if (bSuccess = True) then
												begin
													if (DevCmd <> USB_Success) then
													begin
														PvrErrorCode := PVR_ERROR_UNKNOWN;
														Exit;
													end;
												end;
											end;
										end;
									end;
									bSuccess := UsbCommandSend(USB_DataHddFileEnd, Nil, 0);
									if (bSuccess = True) then
									begin
										pBuffer := @MsgBuf[0];
										MsgSize := UsbRead(pBuffer, MAX_UsbBlockSize);
										CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
										if (DevCmd = USB_Success) then
										begin
											PvrErrorCode := PVR_OK;
											Result := True;
										end else
										begin
											DevError := USB_Err_InvalidCmd;
										end;
									end;
								end else
								begin
									DevError := USB_Err_InvalidCmd;
								end;
							end else
							begin
								if (FActive = True) then
								begin
									PvrErrorCode := UsbToPvrError(DevError);
								end;
							end;
						end else if (FActive = True) then
							PvrErrorCode := PVR_ERROR_UNKNOWN;
					end else if (FActive = True) then
						PvrErrorCode := PVR_ERROR_UNKNOWN;
				end else if (FActive = True) then
						PvrErrorCode := UsbToPvrError(DevError);
			end else if (FActive = True) then
				PvrErrorCode := PVR_ERROR_UNKNOWN;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end;
end;

{ Open a file and check access mode }
function TTopfieldReceiver.OpenFile(PvrPath: String; Mode: LongWord): Integer;
var
	FileInfo, DummyInfo: TTopfieldFileinfo;
	FileListInfo: PFileListInfo;
	AllowAccess, bSuccess: Boolean;
	ListIndex, PvrErrorCode, DummyCode: Cardinal;
	iRetry, FileTime: Integer;
begin
	Result := -1;
	try
		EnterCriticalSection(FFileListBusy);
		if (FFiles >= 0) and (FFileList.Count >= FFiles) then
		begin
			Result := -PVR_ERROR_TOO_MANY_OPEN_FILES;
			exit;
		end;
		if (Mode = tpCreate) then
		begin
			AllowAccess := True;
			if (FFileList.Count > 0) then
			begin
				for ListIndex := 0 to FFileList.Count - 1 do
				begin
					if Assigned(FFileList.Items[ListIndex]) then
					begin
						FileListInfo := FFileList.Items[ListIndex];
						if FileListInfo^.Name = PvrPath then
						begin
							Result := -PVR_ERROR_ACCESS_DENIED;
							AllowAccess := False;
							break;
						end;
					end;
				end;
			end;
			if AllowAccess then
			begin
				if ReadFileInfo(PvrPath, FileInfo) then
				begin
					if (FileInfo.Attr and tpReadOnly > 0) then
					begin
						Result := -PVR_ERROR_ACCESS_DENIED;
						AllowAccess := False;
					end else
					begin
						iRetry := Integer(FAttemptRetry);
						bSuccess := False;
						while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
						begin
							bSuccess := Remove(PvrPath, PvrErrorCode);
							if not bSuccess then
								Dec(iRetry);
						end;
						if not bSuccess then
						begin
							if (FActive = False) then
								PvrErrorCode := PVR_REMOVED
							else if (PvrErrorCode <= PVR_OK) then
								PvrErrorCode := PVR_ERROR_UNKNOWN;
							Result := -PvrErrorCode;
							AllowAccess := False;
						end;
					end;
				end;
			end;

			if AllowAccess then
			begin
				iRetry := Integer(FAttemptRetry);
				bSuccess := False;
				Result := -PVR_REMOVED;
				FileInfo.Name := PvrExtractFileName(PvrPath);
				FileInfo.Size := 0;
				FileInfo.Attr := 0;
				FileTime := DateTimeToFileDate(Now);
				FileInfo.Time := FileTime;
				while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
				begin
					bSuccess := SendData(PvrPath, FileInfo, 0, Nil, 0, PvrErrorCode);
					if not bSuccess then
					begin
						if ReadFileInfo(PvrPath, DummyInfo) then Remove(PvrPath, DummyCode);
						Dec(iRetry);
					end;
				end;
				if not bSuccess then
				begin
					if (FActive = False) then
						PvrErrorCode := PVR_REMOVED
					else if (PvrErrorCode <= PVR_OK) then
						PvrErrorCode := PVR_ERROR_UNKNOWN;

					Result := -PvrErrorCode
				end else
				begin
					try
						New(FileListInfo);
						Inc(FFileHandle);
						FileListInfo^.FileHandle := FFileHandle;
						FileListInfo^.Name := PvrPath;
						FileListInfo^.Size := 0;
						FileListInfo^.Attr := 0;
						FileListInfo^.Time := FileTime;
						FileListInfo^.Mode := tpOpenReadWrite or tpShareExclusive;
						FileListInfo^.FilePointer := 0;
						FileListInfo^.BufferSize := 0;
						FileListInfo^.BufferPosition := 0;
						FFileList.Add(FileListInfo);
						Result := FFileHandle;
					except
						Result := -PVR_ERROR_OUTOFMEMORY;
						if ReadFileInfo(PvrPath, DummyInfo) then Remove(PvrPath, DummyCode);
					end;
				end;
			end;
		end else
		begin
			AllowAccess := True;
			if (FFileList.Count > 0) then
			begin
				for ListIndex := 0 to FFileList.Count - 1 do
				begin
					if Assigned(FFileList.Items[ListIndex]) then
					begin
						FileListInfo := FFileList.Items[ListIndex];
						if FileListInfo^.Name = PvrPath then
						begin
							if (Mode and tpShareExclusive > 0) or (FileListInfo^.Mode and tpShareExclusive > 0)
								or ((Mode and tpOpenReadWrite > 0) and (FileListInfo^.Mode and tpShareDenyNone = 0))
								or ((Mode and 3 = tpOpenRead) and (FileListInfo^.Mode and tpShareDenyRead = tpShareDenyRead))
								or ((Mode and tpOpenWrite > 0) and (FileListInfo^.Mode and tpShareDenyWrite = tpShareDenyWrite)) then
							begin
								Result := -PVR_ERROR_ACCESS_DENIED;
								AllowAccess := False;
								break;
							end;
						end;
					end;
				end;
			end;
			if AllowAccess then
			begin
				Result := -PVR_ERROR_FILE_NOT_FOUND;
				if ReadFileInfo(PvrPath, FileInfo) then
				begin
					if (FileInfo.Attr and tpReadOnly > 0) and (Mode and 3 > 0) then
						Result := -PVR_ERROR_ACCESS_DENIED
					else
					begin
						try
							New(FileListInfo);
							Inc(FFileHandle);
							FileListInfo^.FileHandle := FFileHandle;
							FileListInfo^.Name := PvrPath;
							FileListInfo^.Size := FileInfo.Size;
							FileListInfo^.Attr := FileInfo.Attr;
							FileListInfo^.Time := FileInfo.Time;
							FileListInfo^.Mode := Mode;
							FileListInfo^.FilePointer := 0;
							FileListInfo^.BufferSize := 0;
							FileListInfo^.BufferPosition := 0;
							FFileList.Add(FileListInfo);
							Result := FFileHandle;
						except
							Result := -PVR_ERROR_OUTOFMEMORY;
						end;
					end;
				end;
			end;
		end;
	finally
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{Get file info via file handle }
function TTopfieldReceiver.GetFileListInfo(Handle: Integer; var pInfo: Pointer): Boolean;
var
	ListIndex: Integer;
	FileListInfo: PFileListInfo;
begin
	Result := False;
	pInfo := Nil;
	if (FFileList.Count > 0) then
	begin
		for ListIndex := 0 to FFileList.Count - 1 do
		begin
			if Assigned(FFileList.Items[ListIndex]) then
			begin
				FileListInfo := FFileList.Items[ListIndex];
				if FileListInfo^.FileHandle = Handle then
				begin
					pInfo := FileListInfo;
					Result := True;
					break;
				end;
			end;
		end;
	end;
end;

{ Renam a file on PVR}
function TTopfieldReceiver.Rename(PvrOldPath, PvrNewPath: String; var PvrErrorCode: Cardinal): Boolean;
var
	SizeOldPath, SizeNewPath, SendSize, MsgSize, DevCmd, DevError, DevDataSize, h: Cardinal;
	pBuffer, pData: PByte;
	MsgBuf: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
	bSuccess: BOOL;
begin
	Result := False;
	PvrErrorCode := PVR_REMOVED;
	SizeOldPath := Length(PvrOldPath);
	SizeNewPath := Length(PvrNewPath);

	Put16bit(@MsgBuf[0], SizeOldPath + 1);
	for h := 2 to SizeOldPath + 1 do
		MsgBuf[h] := Ord(PvrOldPath[h - 1]);
	MsgBuf[SizeOldPath + 2] := 0;

	Put16bit(@MsgBuf[SizeOldPath + 2 + 1], SizeNewPath + 1);
	for h := 1 to SizeNewPath do
		MsgBuf[SizeOldPath + 2 + 2 + h] := Ord(PvrNewPath[h]);
	MsgBuf[SizeOldPath + 2 + 2 + SizeNewPath + 1] := 0;
	SendSize := SizeOldPath + 2 + 2 + SizeNewPath + 2;
	pBuffer := @MsgBuf[0];

	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			bSuccess := UsbCommandSend(USB_CmdHddRename, pBuffer, SendSize);
			if (bSuccess = True) then
			begin
				FillChar(MsgBuf, MAX_UsbBlockSize + $1000, #0); // Reset buffer
				pBuffer := @MsgBuf[0];
				MsgSize := UsbRead(pBuffer, 16);
				bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
				if (bSuccess = True) then
				begin
					if (DevCmd = USB_Success) then
					begin
						PvrErrorCode := PVR_OK;
						Result := True;
					end else
					begin
						DevError := USB_Err_InvalidCmd;
						bSuccess := False;
					end;
				end;
				if not bSuccess then
				begin
					if (FActive = False) then
						PvrErrorCode := PVR_REMOVED
					else
						UsbToPvrError(DevError);
				end;
			end else
			begin
				if (FActive = False) then
					PvrErrorCode := PVR_REMOVED
				else
					PvrErrorCode := PVR_ERROR_UNKNOWN;
			end;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end;
end;

{ Get disk size from PVR }
function TTopfieldReceiver.GetDiskSizeInfo(var SizeTotal, SizeFree: LongWord; var PvrErrorCode: Cardinal): Boolean;
var
	MsgSize, DevCmd, DevError, DevDataSize: Cardinal;
	pBuffer, pData: PByte;
	MsgBuf: array [$0..MAX_UsbBlockSize + $1000 - $1] of byte;
	bSuccess: BOOL;
begin
	Result := False;
	SizeTotal := 0;
	SizeFree := 0;
	if (FActive = True) then
	begin
		try
			EnterCriticalSection(FBusy);
			bSuccess := UsbCommandSend(USB_CmdHddSize, Nil, 0);
			if (bSuccess = True) then
			begin
				pBuffer := @MsgBuf[0];
				MsgSize := UsbRead(pBuffer, MAX_UsbBlockSize);
				bSuccess := CheckCmd(pBuffer, MsgSize, DevCmd, DevError, pData, DevDataSize);
				if (bSuccess = True) then
				begin
					if (DevCmd = USB_DataHddSize) then
					begin
						SizeTotal := LongWord(Get32Bit(pData));
						Inc(pData, 4);
						SizeFree := LongWord(Get32Bit(pData));
						PvrErrorCode := PVR_OK;
						Result := True;
					end else
					begin
						DevError := USB_Err_InvalidCmd;
						bSuccess := False;
					end;
				end;
				if not bSuccess then
				begin
					if (FActive = False) then
						PvrErrorCode := PVR_REMOVED
					else
						UsbToPvrError(DevError);
				end;
			end else
			begin
				if (FActive = False) then
					PvrErrorCode := PVR_REMOVED
				else
					PvrErrorCode := PVR_ERROR_UNKNOWN;
			end;
		finally
			LeaveCriticalSection(FBusy);
		end;
	end;
end;

{------------------------------------------------------------------------------}
{ Protected procedures and functions}
{------------------------------------------------------------------------------}
{ Main window procedure }
procedure TTopfieldReceiver.MainWndProc(var Message: TMessage);
begin
	try
		WndProc(Message);
	except
		on E:Exception do
			if Assigned(Application) then
				Application.HandleException(Self)
			else
				raise;
	end;
end;

{ Dispatch messages }
procedure TTopfieldReceiver.WndProc(var Message: TMessage);
begin
	Dispatch(Message);
end;

{------------------------------------------------------------------------------}
{ Public procedures and functions }
{------------------------------------------------------------------------------}
{ Default windows handler }
procedure TTopfieldReceiver.DefaultHandler(var Message);
begin
	TMessage(Message).Result := DefWindowProc(Handle, TMessage(Message).Msg,TMessage(Message).wParam, TMessage(Message).lParam)
end;

{ Try to notify the device }
procedure TTopfieldReceiver.StartNotifyDevice;
begin
	if ((FDllAvailable = True) and (FHandle <> 0) and (FNotificationStarted = False)) then
	begin
		if Assigned(FOnBeforeNotifyDevice) then FOnBeforeNotifyDevice(Self);
		if (StartPnpNotice(FHandle)) then
		begin
			FNotificationStarted := True;
			SendMessage(FHandle, WM_COMMAND, wParam(DEVICE_ARRIVAL_MSG), 0);
		end else
		begin
			FNotificationStarted := True;
			if Assigned(FOnTryNotifyDevice) then FOnTryNotifyDevice(Self);
			if (FTimerEventID = 0) then begin
				FTimerEventID := 1;
				if SetTimer(FHandle, FTimerEventID, FTimerInterval, nil) = 0 then
				begin
					FTimerEventID := 0;
					raise EOutOfResources.Create(SNoTimers);
				end;
			end;
		end;
	end else
	begin
		if (FDllAvailable = False) then
		begin
			raise EPvrError.Create(PVR_ERROR_NOTFDLL, 'TFDLL.DLL not found.');
		end else if (FHandle = 0) then
		begin
			raise EPvrError.Create(PVR_ERROR_INVALID_HANDLE, 'Handle is not assigned.');
		end else
		begin
			raise EPvrError.Create(PVR_ERROR_NOTIFY, 'Device notification is already started.');
		end;
	end;
end;

{ Find first file / path }
function TTopfieldReceiver.FindFirst(const Path: string; Attr: Integer; var F: TTopfieldSearchRec): Integer;
const
	tpSpecial = tpHidden or tpSysFile or tpVolumeID or tpDirectory;
var
	SearchPath, SearchName, PvrPath: String;
	ExcludeAttr, iRetry: Integer;
	FirstBlock: PFileBlock;
	PvrErrorCode, SearchError: Cardinal;
	bSuccess: Boolean;
	FileSearchRec: TTopfieldSearchRec;
begin
	Result := PVR_ERROR_FILE_NOT_FOUND;
	PvrPath := WinToPvrPath(Path);
	SearchPath := PvrExtractFilePath(PvrPath);
	SearchName := PvrExtractFileName(PvrPath);
	FirstBlock := Nil;
	F.Name := '';
	F.Time := 0;
	F.Week := 0;
	F.Size := 0;
	F.Attr := 0;
	F.ExcludeAttr := not F.Attr;
	F.FindHandle := 0;
	if (SearchName = '') then
		Exit;
	if (SearchPath = '') then
	begin
		Result := PVR_ERROR_PATH_NOT_FOUND;
		Exit;
	end;
	ExcludeAttr := not Attr and tpSpecial;
	iRetry := Integer(FAttemptRetry);
	bSuccess := False;
	while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
	begin
		bSuccess := GetFileBlock(SearchPath, SearchName, ExcludeAttr, FirstBlock, PvrErrorCode);
		if not bSuccess then
		begin
			if Assigned(FirstBlock) then
			begin
				FreeBlock(FirstBlock);
				FirstBlock := Nil;
			end;
			Dec(iRetry);
		end;
	end;
	if bSuccess then
	begin
		bSuccess := FindSearchRec(FirstBlock, FileSearchRec, SearchError);
		if bSuccess then
		begin
			F.Name := FileSearchRec.Name;
			F.Time := FileSearchRec.Time;
			F.Week := FileSearchRec.Week;
			F.Size := FileSearchRec.Size;
			F.Attr := FileSearchRec.Attr;
			F.ExcludeAttr := FileSearchRec.ExcludeAttr;
			F.FindHandle := FileSearchRec.FindHandle;
			Result := PVR_OK;
		end else
		begin
			FreeRecBlock(FirstBlock);
			Result := SearchError;
		end;
	end else
	begin
		if Assigned(FirstBlock) then
			FreeBlock(FirstBlock);
		Result := PvrErrorCode;
	end;
end;

{ Find next file / path }
function TTopfieldReceiver.FindNext(var F: TTopfieldSearchRec): Integer;
var
	pBlock, StartBlock: PFileBlock;
	SearchError: Cardinal;
	bSuccess: Boolean;
	FileSearchRec: TTopfieldSearchRec;
begin
	Result := PVR_ERROR_FILE_NOT_FOUND;
	if (F.FindHandle <> 0) then
	begin
		pBlock := PFileBlock(F.FindHandle);
		StartBlock := pBlock^.NextData;
		bSuccess := FindSearchRec(StartBlock, FileSearchRec, SearchError);
		if bSuccess then
		begin
			F.Name := FileSearchRec.Name;
			F.Time := FileSearchRec.Time;
			F.Week := FileSearchRec.Week;
			F.Size := FileSearchRec.Size;
			F.Attr := FileSearchRec.Attr;
			F.ExcludeAttr := FileSearchRec.ExcludeAttr;
			F.FindHandle := FileSearchRec.FindHandle;
			Result := PVR_OK;
		end;
	end;
end;

{ Close find first and free memory }
procedure TTopfieldReceiver.FindClose(var F: TTopfieldSearchRec);
var
	StartBlock, FirstBlock: PFileBlock;
begin
	if (F.FindHandle <> 0) then
	begin
		StartBlock := PFileBlock(F.FindHandle);
		FirstBlock := StartBlock^.FirstData;
		FreeRecBlock(FirstBlock);
	end;
	F.Name := '';
	F.Time := 0;
	F.Week := 0;
	F.Size := 0;
	F.Attr := 0;
	F.ExcludeAttr := not F.Attr;
	F.FindHandle := 0;
end;

{ Get the current directory }
function TTopfieldReceiver.GetCurrentDir: string;
begin
	if PathExists(FCurrentDir) then
	begin
		try
			EnterCriticalSection(FCurDirBusy);
			Result := PvrToWinPath(FCurrentDir);
		finally
			LeaveCriticalSection(FCurDirBusy);
		end;
	end else begin
		try
			EnterCriticalSection(FCurDirBusy);
			FCurrentDir := '\';
			Result := PvrToWinPath(FCurrentDir);
		finally
			LeaveCriticalSection(FCurDirBusy);
		end;
	end;
end;

{ Set the current directory }
function TTopfieldReceiver.SetCurrentDir(const Dir: string): Boolean;
var
	CurDir: String;
begin
	Result := False;
	CurDir := WinToPvrPath(Dir);
	if (CurDir <> '\') then
		CurDir := ExcludeTrailingBackslash(CurDir);
	if PathExists(CurDir) then
	begin
		try
			EnterCriticalSection(FCurDirBusy);
			FCurrentDir := CurDir;
		finally
			LeaveCriticalSection(FCurDirBusy);
		end;
		Result := True;
	end;
end;

{ Get drive - also gets windows drives }
procedure TTopfieldReceiver.GetDir(D: Byte; var S: string);
begin
	if (D = Ord(FPvrDrive)) then
		S := GetCurrentDir
	else
		System.GetDir(D, S);
end;

{ Change Current directory }
procedure TTopfieldReceiver.ChDir(S: string);
begin
	if not SetCurrentDir(S) then
		raise EPvrError.Create(PVR_ERROR_DIRECTORY, 'Can not change current directory.');
end;

{ Check if directory exists }
function TTopfieldReceiver.DirectoryExists(Name: string): Boolean;
var
	Dir: String;
begin
	Dir := WinToPvrPath(Name);
	Result := PathExists(Dir);
end;

{ Make new directory }
procedure TTopfieldReceiver.MkDir(S: string);
var
	PvrPath, Path, Name : String;
	PvrErrorCode: Cardinal;
	bSuccess: Boolean;
	iRetry: Integer;
begin
	PvrPath := WinToPvrPath(S);
	if (PvrPath <> '\') then
		PvrPath := ExcludeTrailingBackslash(PvrPath);

	Path := PvrExtractFilePath(PvrPath);
	Name := PvrExtractFileName(PvrPath);

	if (Path <> '\') then
		Path := ExcludeTrailingBackslash(Path);

	if (Path = '') or (Name = '') or PathExists(PvrPath) or not PathExists(Path) then
	begin
		PvrErrorCode := PVR_ERROR_BAD_PATHNAME;
		bSuccess := False;
	end else
	begin
		iRetry := Integer(FAttemptRetry);
		bSuccess := False;
		while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
		begin
			bSuccess := CreateDirectory(PvrPath, PvrErrorCode);
			if not bSuccess then
				Dec(iRetry);
		end;
	end;
	if not bSuccess then
		raise EPvrError.Create(PVR_ERROR_DIRECTORY, 'Can not create directory.');
end;

{ Create directory }
function TTopfieldReceiver.CreateDir(const Dir: string): Boolean;
begin
	try
		MkDir(Dir);
		Result := True;
	except
		Result := False;
	end;
end;

{ remove directory }
procedure TTopfieldReceiver.RmDir(S: string);
var
	PvrPath, Path, Name : String;
	PvrErrorCode: Cardinal;
	bSuccess: Boolean;
	iRetry: Integer;
begin
	PvrPath := WinToPvrPath(S);
	if (PvrPath <> '\') then
		PvrPath := ExcludeTrailingBackslash(PvrPath);

	Path := PvrExtractFilePath(PvrPath);
	Name := PvrExtractFileName(PvrPath);

	if (Path <> '\') then
		Path := ExcludeTrailingBackslash(Path);

	if (Path = '') or (Name = '') or not PathExists(PvrPath) then
	begin
		PvrErrorCode := PVR_ERROR_BAD_PATHNAME;
		bSuccess := False;
	end else if not IsEmptyDir(PvrPath) then
	begin
		PvrErrorCode := PVR_ERROR_DIR_NOT_EMPTY;
		bSuccess := False;
	end else if (PvrPath = GetCurrentDir) then
	begin
	   PvrErrorCode := PVR_ERROR_PATH_BUSY;
	   bSuccess := False;
	end else
	begin
		iRetry := Integer(FAttemptRetry);
		bSuccess := False;
		while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
		begin
			bSuccess := Remove(PvrPath, PvrErrorCode);
			if not bSuccess then
				Dec(iRetry);
		end;
	end;
	if not bSuccess then
		raise EPvrError.Create(PVR_ERROR_DIRECTORY, 'Can not remove directory.');
end;

{ remove directory }
function TTopfieldReceiver.RemoveDir(const Dir: string): Boolean;
begin
	try
		RmDir(Dir);
		Result := True;
	except
		Result := False;
	end;
end;

{ Create directory path }
function TTopfieldReceiver.ForceDirectories(Dir: string): Boolean;
var
	PvrPath: String;
begin
	Result := True;
	PvrPath := WinToPvrPath(Dir);
	if (PvrPath <> '\') then
		PvrPath := ExcludeTrailingBackslash(PvrPath);

	if Length(PvrPath) = 0 then
		raise EPvrError.Create(PVR_ERROR_DIRECTORY, 'Can not create directory.');

	if (Length(PvrPath) < 2) or DirectoryExists(PvrPath)
		or (PvrExtractFilePath(PvrPath) = PvrPath) then Exit;

	Result := ForceDirectories(PvrExtractFilePath(PvrPath)) and CreateDir(PvrPath);
end;

{ Check if file exists }
function TTopfieldReceiver.FileExists(const FileName: string): Boolean;
var
	PvrPath, Path, Name: String;
	FileInfo: TTopfieldFileinfo;
begin
	Result := False;
	PvrPath := WinToPvrPath(FileName);
	Path := PvrExtractFilePath(PvrPath);
	Name := PvrExtractFileName(PvrPath);
	if (Path <> '\') then
		Path := ExcludeTrailingBackslash(Path);
	if (Path <> '') and (Name <> '') then
		Result := ReadFileInfo(PvrPath, FileInfo);
end;

{ Create a file }
function TTopfieldReceiver.FileCreate(const FileName: string): Integer;
var
	PvrPath, Path, Name: String;
begin
	Result := -PVR_ERROR_INVALID_NAME;
	PvrPath := WinToPvrPath(FileName);
	Path := PvrExtractFilePath(PvrPath);
	Name := PvrExtractFileName(PvrPath);

	if (Path <> '\') then
		Path := ExcludeTrailingBackslash(Path);

	if (Path <> '') and (Name <> '') and PathExists(Path) then
		Result := OpenFile(PvrPath, tpCreate);
end;

{ Open a file with file mode }
function TTopfieldReceiver.FileOpen(const FileName: string; Mode: LongWord): Integer;
var
	FileMode, ShareMode: LongWord;
	PvrPath, Path, Name: String;
begin
	Result := -PVR_ERROR_INVALID_NAME;
	FileMode := Mode and $0F;
	ShareMode := Mode and $F0;
	if (FileMode > tpOpenReadWrite) then
	begin
		Result := -PVR_ERROR_INVALID_PARAMETER;
		exit;
	end;
	if (ShareMode = tpShareCompat) then
		ShareMode := tpShareExclusive
	else if not ((ShareMode >= tpShareExclusive) and (ShareMode <= tpShareDenyNone)) then
	begin
		Result := -PVR_ERROR_INVALID_PARAMETER;
		exit;
	end;

	PvrPath := WinToPvrPath(FileName);
	Path := PvrExtractFilePath(PvrPath);
	Name := PvrExtractFileName(PvrPath);

	if (Path <> '\') then
		Path := ExcludeTrailingBackslash(Path);

	if (Path <> '') and (Name <> '') then
		Result := OpenFile(PvrPath, FileMode or ShareMode);
end;

{ Close a file }
procedure TTopfieldReceiver.FileClose(Handle: Integer);
var
	ListIndex: Integer;
	FileListInfo: PFileListInfo;
begin
	try
		EnterCriticalSection(FFileListBusy);
		if (FFileList.Count > 0) then
		begin
			for ListIndex := 0 to FFileList.Count - 1 do
			begin
				if Assigned(FFileList.Items[ListIndex]) then
				begin
					FileListInfo := FFileList.Items[ListIndex];
					if FileListInfo^.FileHandle = Handle then
					begin
						FFileList.Delete(ListIndex);
						Dispose(FileListInfo);
						break;
					end;
				end;
			end;
		end;
	finally
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{ Seek on a file position - only read operation supported }
function TTopfieldReceiver.FileSeek(Handle, Offset, Origin: Integer): Integer;
var
	Offset64, Position64: Int64;
begin
	Offset64 := Int64(Offset);
	Position64 := FileSeek(Handle, Offset64, Origin);
	if (Position64 < Int64(0)) then
	begin
		Result := Integer(Position64);
	end else
	begin
		if (Cardinal(Position64) > Cardinal(High(Result))) then
			Result := Integer(Cardinal(Position64) - Cardinal(High(Result)))
		else
			Result := Integer(Position64);
	end;
end;

{ Seek on a file position - only read operation supported }
function TTopfieldReceiver.FileSeek(Handle: Integer; const Offset: Int64; Origin: Integer): Int64;
var
	FileListInfo: PFileListInfo;
	StartFilePointer: Int64;
begin
	if (FActive = False) then
	begin
		Result := -PVR_ERROR_SEEK_ON_DEVICE;
		exit;
	end;
	if (Origin > 2) or (Origin < 0) then
	begin
		Result := -PVR_ERROR_INVALID_PARAMETER;
		exit;
	end;
	try
		EnterCriticalSection(FFileListBusy);
		Result := -PVR_ERROR_INVALID_HANDLE;
		if GetFileListInfo(Handle, Pointer(FileListInfo)) then
		begin
			if (Origin = 0) then
				StartFilePointer := 0
			else if (Origin = 1) then
				StartFilePointer := FileListInfo^.FilePointer
			else
				StartFilePointer := FileListInfo^.Size;

			Result := StartFilePointer + Offset;
			if (Result < Int64(0)) then
				Result := -PVR_ERROR_NEGATIVE_SEEK
			else
				FileListInfo^.FilePointer := Result;
		end;
	finally
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{ Delete a file }
function TTopfieldReceiver.DeleteFile(const FileName: string): Boolean;
var
	PvrPath, Path, Name: String;
	PvrErrorCode: Cardinal;
	bSuccess: Boolean;
	ListIndex, iRetry: Integer;
	FileListInfo: PFileListInfo;
	FileInfo: TTopfieldFileinfo;
begin
	try
		EnterCriticalSection(FFileListBusy);
		Result := False;
		PvrPath := WinToPvrPath(FileName);
		Path := PvrExtractFilePath(PvrPath);
		Name := PvrExtractFileName(PvrPath);

		if (Path <> '\') then
			Path := ExcludeTrailingBackslash(Path);

		if (Path <> '') and (Name <> '') and ReadFileInfo(PvrPath, FileInfo) then
		begin
			bSuccess := True;

			if (FileInfo.Attr and tpReadOnly > 0) then
				bSuccess := False;

			if bSuccess then
			begin
				if (FFileList.Count > 0) then
				begin
					for ListIndex := 0 to FFileList.Count - 1 do
					begin
						if Assigned(FFileList.Items[ListIndex]) then
						begin
							FileListInfo := FFileList.Items[ListIndex];
							if FileListInfo^.Name = PvrPath then
							begin
								bSuccess := False;
								break;
							end;
						end;
					end;
				end;
			end;

			if bSuccess then
			begin
				bSuccess := False;
				iRetry := Integer(FAttemptRetry);
				while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
				begin
					bSuccess := Remove(PvrPath, PvrErrorCode);
					if not bSuccess then
						Dec(iRetry);
				end;
				if bSuccess then
					Result := True;
			end;
		end;
	finally
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{ Search a file from list}
function TTopfieldReceiver.FileSearch(const Name, DirList: string): string;
var
	PvrList, Path, PvrPath: String;
	Idx: Integer;
	FileInfo: TTopfieldFileinfo;
begin
	Result := '';
	if (Name = '') or (DirList = '') then
		exit;
	PvrList := DirList;
	if AnsiLastChar(PvrList)^ = ';' then
		PvrList := PvrList + ';';

	Idx := Pos(';', PvrList);
	while (Idx > 0) do
	begin
		Path := Copy(PvrList, 1, Idx - 1);
		PvrList := Copy(PvrList, Idx + 1, Length(PvrList) - Idx);
		Idx := Pos(';', PvrList);
		if not (AnsiLastChar(Path)^ in [':', '\']) then Path := Path + '\';
		Path := Path + Name;

		PvrPath := WinToPvrPath(Path);

		if ReadFileInfo(PvrPath, FileInfo) then
		begin
			Result := PvrToWinPath(PvrPath);
			break;
		end;
	end;
end;

{ Get the file age }
function TTopfieldReceiver.FileAge(const FileName: string): Integer;
var
	PvrPath, Path, Name: String;
	FileInfo: TTopfieldFileinfo;
begin
	Result := -1;
	PvrPath := WinToPvrPath(FileName);
	Path := PvrExtractFilePath(PvrPath);
	Name := PvrExtractFileName(PvrPath);
	if (Path <> '\') then
		Path := ExcludeTrailingBackslash(Path);
	if (Path <> '') and (Name <> '') and (ReadFileInfo(PvrPath, FileInfo) = True) then
		Result := FileInfo.Time;
end;

{ Get the file attribute }
function TTopfieldReceiver.FileGetAttr(const FileName: string): Integer;
var
	PvrPath, Path, Name: String;
	FileInfo: TTopfieldFileinfo;
begin
	Result := -1;
	PvrPath := WinToPvrPath(FileName);
	Path := PvrExtractFilePath(PvrPath);
	Name := PvrExtractFileName(PvrPath);
	if (Path <> '\') then
		Path := ExcludeTrailingBackslash(Path);
	if (Path <> '') and (Name <> '') and (ReadFileInfo(PvrPath, FileInfo) = True) then
		Result := FileInfo.Attr;
end;

{ Get the file date }
function TTopfieldReceiver.FileGetDate(Handle: Integer): Integer;
var
	FileListInfo: PFileListInfo;
begin
	Result := -1;
	if (FActive = False) then
		exit;
	try
		EnterCriticalSection(FFileListBusy);
		if GetFileListInfo(Handle, Pointer(FileListInfo)) then
			Result := FileListInfo^.Time;
	finally
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{ Get the file info structure }
function TTopfieldReceiver.GetFileInfo(const FileName: string; var FileInfo: TTopfieldFileinfo): Boolean;
var
	PvrPath, Path, Name: String;
begin
	Result := False;
	PvrPath := WinToPvrPath(FileName);
	Path := PvrExtractFilePath(PvrPath);
	Name := PvrExtractFileName(PvrPath);
	if (Path <> '\') then
		Path := ExcludeTrailingBackslash(Path);
	if (Path <> '') and (Name <> '') then
		Result := ReadFileInfo(PvrPath, FileInfo);
end;

{ Set file attributes }
function TTopfieldReceiver.FileSetAttr(const FileName: string; Attr: Integer): Integer;
var
	PvrPath, Path, Name: String;
	FileInfo: TTopfieldFileinfo;
	PvrErrorCode: Cardinal;
	bSuccess: Boolean;
	iRetry, ListIndex: Integer;
	FileListInfo: PFileListInfo;
begin
	try
		EnterCriticalSection(FFileListBusy);
		Result := -PVR_ERROR_INVALID_NAME;
		Attr := Attr and $27;
		PvrPath := WinToPvrPath(FileName);
		Path := PvrExtractFilePath(PvrPath);
		Name := PvrExtractFileName(PvrPath);

		if (Path <> '\') then
			Path := ExcludeTrailingBackslash(Path);

		if (Path <> '') and (Name <> '') and (ReadFileInfo(PvrPath, FileInfo) = True) then
		begin
			iRetry := Integer(FAttemptRetry);
			bSuccess := False;
			FileInfo.Attr := Attr;
			while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
			begin
				bSuccess := SendData(PvrPath, FileInfo, FileInfo.Size, Nil, 0, PvrErrorCode);
				if not bSuccess then
					Dec(iRetry);
			end;
			if not bSuccess then
			begin
				if (FActive = False) then
					PvrErrorCode := PVR_REMOVED
				else if (PvrErrorCode <= PVR_OK) then
					PvrErrorCode := PVR_ERROR_UNKNOWN;

				Result := -PvrErrorCode;
			end else
			begin
				if (FFileList.Count > 0) then
				begin
					for ListIndex := 0 to FFileList.Count - 1 do
					begin
						if Assigned(FFileList.Items[ListIndex]) then
						begin
							FileListInfo := FFileList.Items[ListIndex];
							if FileListInfo^.Name = PvrPath then
								FileListInfo^.Attr := Attr;
						end;
					end;
				end;
				Result := PVR_OK;
			end;
		end;
	finally
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{ Set file date }
function TTopfieldReceiver.FileSetDate(Handle: Integer; Age: Integer): Integer;
var
	FileListInfo: PFileListInfo;
	FileInfo: TTopfieldFileinfo;
	iRetry, ListIndex: Integer;
	PvrPath: String;
	bSuccess: Boolean;
	PvrErrorCode: Cardinal;
begin
	Result := PVR_ERROR_INVALID_HANDLE;
	if (FActive = False) then
	begin
		Result := PVR_REMOVED;
		Exit;
	end;
	try
		EnterCriticalSection(FFileListBusy);
		if GetFileListInfo(Handle, Pointer(FileListInfo)) then
		begin
			if not ((FileListInfo^.Mode and tpOpenWrite = tpOpenWrite) or (FileListInfo^.Mode and tpOpenReadWrite = tpOpenReadWrite)) then
			begin
				Result := PVR_ERROR_ACCESS_DENIED;
				Exit;
			end;

			PvrPath := FileListInfo^.Name;
			if (ReadFileInfo(PvrPath, FileInfo) = True) then
			begin
				iRetry := Integer(FAttemptRetry);
				bSuccess := False;
				FileInfo.Time := Age;
				while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
				begin
					bSuccess := SendData(PvrPath, FileInfo, FileInfo.Size, Nil, 0, PvrErrorCode);
					if not bSuccess then
						Dec(iRetry);
				end;
				if not bSuccess then
				begin
					if (FActive = False) then
						PvrErrorCode := PVR_REMOVED
					else if (PvrErrorCode <= PVR_OK) then
						PvrErrorCode := PVR_ERROR_UNKNOWN;

					Result := PvrErrorCode;
				end else
				begin
					FileListInfo^.Time := Age;
					if (FFileList.Count > 0) then
					begin
						for ListIndex := 0 to FFileList.Count - 1 do
						begin
							if Assigned(FFileList.Items[ListIndex]) then
							begin
								FileListInfo := FFileList.Items[ListIndex];
								if FileListInfo^.Name = PvrPath then
									FileListInfo^.Time := Age;
							end;
						end;
					end;
					Result := PVR_OK;
				end;
			end else
				Result := PVR_ERROR_FILE_NOT_FOUND;
		end;
	finally
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{ Rename a file }
function TTopfieldReceiver.RenameFile(const OldName, NewName: string): Boolean;
var
	PvrOldPath, PvrNewPath, OldPath, OldExName, NewPath, NewExName: String;
	PvrErrorCode: Cardinal;
	bSuccess: Boolean;
	ListIndex, iRetry: Integer;
	FileListInfo: PFileListInfo;
	IsOldDirectory, OldExists, NewExists: Boolean;
	SearchRec: TTopfieldSearchRec;
begin
	Result := False;
	OldExists := False;
	NewExists := False;
	IsOldDirectory := False;
	PvrOldPath := WinToPvrPath(OldName);
	OldPath := PvrExtractFilePath(PvrOldPath);
	OldExName := PvrExtractFileName(PvrOldPath);
	PvrNewPath := WinToPvrPath(NewName);
	NewPath := PvrExtractFilePath(PvrNewPath);
	NewExName := PvrExtractFileName(PvrNewPath);

	if (OldPath <> '\') then
		OldPath := ExcludeTrailingBackslash(OldPath);

	if (NewPath <> '\') then
		NewPath := ExcludeTrailingBackslash(NewPath);

	if (OldPath = '') or (OldExName = '') or (NewPath = '') or (NewExName = '') then
		Exit;

	if FindFirst(OldName, tpAnyFile, SearchRec) = 0 then
	begin
		if SearchRec.Attr and tpDirectory <> 0 then
			IsOldDirectory := True
		else
			IsOldDirectory := False;
		OldExists := True;
	end;
	FindClose(SearchRec);
	if not OldExists then
		Exit;

	if FindFirst(NewName, tpAnyFile, SearchRec) = 0 then
	begin
		NewExists := True;
	end;

	FindClose(SearchRec);
	if NewExists then
		Exit;
	try
		EnterCriticalSection(FCurDirBusy);
		EnterCriticalSection(FFileListBusy);
		if (IsOldDirectory = True) and (FCurrentDir = PvrOldPath) then
			Exit;
		bSuccess := True;
		if (FFileList.Count > 0) then
		begin
			for ListIndex := 0 to FFileList.Count - 1 do
			begin
				if Assigned(FFileList.Items[ListIndex]) then
				begin
					FileListInfo := FFileList.Items[ListIndex];
					if Pos(PvrOldPath, FileListInfo^.Name) = 1 then
					begin
						bSuccess := False;
						break;
					end;
				end;
			end;
		end;
		if bSuccess then
		begin
			bSuccess := False;
			iRetry := Integer(FAttemptRetry);
			while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
			begin
				bSuccess := Rename(PvrOldPath, PvrNewPath, PvrErrorCode);
				if not bSuccess then
					Dec(iRetry);
			end;
			if bSuccess then
				Result := True;
		end;
	finally
		LeaveCriticalSection(FCurDirBusy);
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{ Read data from a file }
function TTopfieldReceiver.FileRead(Handle: Integer; var Buffer; Count: LongWord): Integer;
var
	FileListInfo: PFileListInfo;
	FileInfo: TTopfieldFileinfo;
	iRetry: Integer;
	PvrPath: String;
	bSuccess: Boolean;
	PvrErrorCode: Cardinal;
	pBuffer: Pointer;
	Mode: LongWord;
	HelpFilePointer: Int64;
	StartPosition, MoveCount, SizeRead: Integer;
begin
	Result := -PVR_ERROR_INVALID_HANDLE;
	if (FActive = False) then
	begin
		Result := -PVR_REMOVED;
		exit;
	end;
	if (Integer(Count) < 0) then
	begin
		Result := -PVR_ERROR_INVALID_PARAMETER;
		exit;
	end;
	try
		EnterCriticalSection(FFileListBusy);
		if GetFileListInfo(Handle, Pointer(FileListInfo)) then
		begin
			Mode := FileListInfo^.Mode and $000F;
			if not ((Mode = tpOpenRead) or (Mode = tpOpenReadWrite)) then
			begin
				Result := -PVR_ERROR_ACCESS_DENIED;
				Exit;
			end;

			PvrPath := FileListInfo^.Name;
			if (ReadFileInfo(PvrPath, FileInfo) = True) then
			begin
				if (FileListInfo^.FilePointer >= FileInfo.Size) or (Count = 0) then
				begin
					Result := 0;
					Exit;
				end;

				pBuffer := @Buffer;
				MoveCount := 0;
				if (FileListInfo^.BufferSize > 0) and (FileListInfo^.FilePointer >= FileListInfo^.BufferPosition) and (FileListInfo^.FilePointer < FileListInfo^.BufferPosition + Int64(FileListInfo^.BufferSize)) then
				begin
					StartPosition := Integer(FileListInfo^.FilePointer - FileListInfo^.BufferPosition);
					MoveCount := FileListInfo^.BufferSize - StartPosition;
					if (Integer(Count) <= MoveCount) then
						MoveCount := Count;
					Move(FileListInfo^.Buffer[StartPosition],pBuffer^,MoveCount);
					FileListInfo^.FilePointer := FileListInfo^.FilePointer + Int64(MoveCount);
					Count := Count - LongWord(MoveCount);
					if (Count = 0) then
					begin
						Result := MoveCount;
						Exit;
					end;
					pBuffer := Pointer(Integer(pBuffer) + MoveCount);
				end;

				iRetry := Integer(FAttemptRetry);
				bSuccess := False;
				SizeRead := 0;
				HelpFilePointer := FileListInfo^.FilePointer;
				while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
				begin
					bSuccess := ReadData(PvrPath, Pointer(FileListInfo), pBuffer, Count, SizeRead, PvrErrorCode);
					if not bSuccess then
					begin
						FileListInfo^.FilePointer := HelpFilePointer;
						SizeRead := 0;
						Dec(iRetry);
					end;
				end;
				if not bSuccess then
				begin
					if (FActive = False) then
						PvrErrorCode := PVR_REMOVED;
					Result := -PvrErrorCode;
				end else
				begin
					Result := SizeRead + MoveCount;
				end;
			end else
				Result := -PVR_ERROR_FILE_NOT_FOUND;
		end;
	finally
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{ Write data to a file - support append only }
function TTopfieldReceiver.FileWrite(Handle: Integer; const Buffer; Count: LongWord): Integer;
var
	FileListInfo: PFileListInfo;
	FileInfo: TTopfieldFileinfo;
	iRetry, ListIndex: Integer;
	PvrPath: String;
	bSuccess: Boolean;
	PvrErrorCode: Cardinal;
	pBuffer: Pointer;
	StartPosition: Int64;
begin
	Result := -PVR_ERROR_INVALID_HANDLE;
	if (FActive = False) then
	begin
		Result := -PVR_REMOVED;
		exit;
	end;
	if (Integer(Count) < 0) then
	begin
		Result := -PVR_ERROR_INVALID_PARAMETER;
		exit;
	end;
	try
		EnterCriticalSection(FFileListBusy);
		if GetFileListInfo(Handle, Pointer(FileListInfo)) then
		begin
			if not ((FileListInfo^.Mode and tpOpenWrite = tpOpenWrite) or (FileListInfo^.Mode and tpOpenReadWrite = tpOpenReadWrite)) then
			begin
				Result := -PVR_ERROR_ACCESS_DENIED;
				Exit;
			end;

			PvrPath := FileListInfo^.Name;
			if (ReadFileInfo(PvrPath, FileInfo) = True) then
			begin
				iRetry := Integer(FAttemptRetry);
				bSuccess := False;

				if (FileListInfo^.FilePointer >= FileInfo.Size) then
					FileListInfo^.FilePointer := FileInfo.Size;

				StartPosition := FileListInfo^.FilePointer;
				FileInfo.Size := FileListInfo^.FilePointer + Int64(Count);
				if (Count = 0) then
					pBuffer := Nil
				else
					pBuffer := @Buffer;
				while ((FActive = True) and (bSuccess = False) and (iRetry >= 0)) do
				begin
					bSuccess := SendData(PvrPath, FileInfo, StartPosition, pBuffer, Count, PvrErrorCode);
					if not bSuccess then
						Dec(iRetry);
				end;
				if not bSuccess then
				begin
					if (FActive = False) then
						PvrErrorCode := PVR_REMOVED;
					Result := -PvrErrorCode;
				end else
				begin
					FileListInfo^.Size := FileInfo.Size;
					FileListInfo^.FilePointer := FileInfo.Size;
					if (FFileList.Count > 0) then
					begin
						for ListIndex := 0 to FFileList.Count - 1 do
						begin
							if Assigned(FFileList.Items[ListIndex]) then
							begin
								FileListInfo := FFileList.Items[ListIndex];
								if FileListInfo^.Name = PvrPath then
									FileListInfo^.Size := FileInfo.Size;
							end;
						end;
					end;
					Result := Integer(Count);
				end;
			end else
				Result := -PVR_ERROR_FILE_NOT_FOUND;
		end;
	finally
		LeaveCriticalSection(FFileListBusy);
	end;
end;

{ Get total and free space of disk }
function TTopfieldReceiver.GetDiskSize(var TotalSize, FreeSize: Cardinal): Boolean;
var
	PvrErrorCode: Cardinal;
begin
	Result := GetDiskSizeinfo(TotalSize, FreeSize, PvrErrorCode);
end;

{ Copies a file from / to Receiver }
function TTopfieldReceiver.CopyFile(Source, Destination: String): Boolean;
var
	bSource, bDest: Boolean;
	pSource, pDest: PChar;
begin
	Result := False;
	if (FActive = True) then
	begin
		bSource := ((Source <> '') and (FPvrDrive = Source[1]));
		bDest := ((Destination <> '') and (FPvrDrive = Destination[1]));
		if (bSource <> bDest) then
		begin
			if (bSource = True) then
			begin
				pSource := PChar(WinToPvrPath(Source));
				pDest := PChar(Destination);
				EnterCriticalSection(FBusy);
				EnterCriticalSection(FFileListBusy);
				EnterCriticalSection(FCurDirBusy);
				EnterCriticalSection(FCopyBusy);
				FInCopy := True;
				if Assigned(FOnBeforeCopyFile) then FOnBeforeCopyFile(Self);
				if UsbTaskFileReceive(pDest, pSource, FHandle, TASK_RECEIVEFILE) = False then
				begin
					FInCopy := False;
					LeaveCriticalSection(FCopyBusy);
					LeaveCriticalSection(FCurDirBusy);
					LeaveCriticalSection(FFileListBusy);
					LeaveCriticalSection(FBusy);
				end else
				begin
					Result := True;
				end;
			end else
			begin
				pSource := PChar(Source);
				pDest := PChar(WinToPvrPath(Destination));
				EnterCriticalSection(FBusy);
				EnterCriticalSection(FFileListBusy);
				EnterCriticalSection(FCurDirBusy);
				EnterCriticalSection(FCopyBusy);
				FInCopy := True;
				if Assigned(FOnBeforeCopyFile) then FOnBeforeCopyFile(Self);
				if UsbTaskFileSend(pDest, pSource, FHandle, TASK_SENDFILE) = False then
				begin
					FInCopy := False;
					LeaveCriticalSection(FCopyBusy);
					LeaveCriticalSection(FCurDirBusy);
					LeaveCriticalSection(FFileListBusy);
					LeaveCriticalSection(FBusy);
				end else
				begin
					Result := True;
				end;
			end;
		end;
	end;
end;

{ Copies a file from / to Receiver from a given Position }
function TTopfieldReceiver.CopyFileFromPos(Source, Destination: String; Position: Int64): Boolean;
var
	bSource, bDest: Boolean;
	pSource, pDest: PChar;
	MSB, LSB: Cardinal;
begin
	Result := False;
	if (FActive = True) then
	begin
		bSource := ((Source <> '') and (FPvrDrive = Source[1]));
		bDest := ((Destination <> '') and (FPvrDrive = Destination[1]));
		MSB := Cardinal(Position shr 32);
		LSB := Cardinal(Position);
		if (bSource <> bDest) then
		begin
			if (bSource = True) then
			begin
				pSource := PChar(WinToPvrPath(Source));
				pDest := PChar(Destination);
				EnterCriticalSection(FBusy);
				EnterCriticalSection(FFileListBusy);
				EnterCriticalSection(FCurDirBusy);
				EnterCriticalSection(FCopyBusy);
				FInCopy := True;
				if UsbTaskFileReceivePosi(pDest, pSource, FHandle, TASK_RECEIVEFILE, MSB, LSB) = False then
				begin
					FInCopy := False;
					LeaveCriticalSection(FCopyBusy);
					LeaveCriticalSection(FCurDirBusy);
					LeaveCriticalSection(FFileListBusy);
					LeaveCriticalSection(FBusy);
				end else
				begin
					Result := True;
				end;
			end else
			begin
				pSource := PChar(Source);
				pDest := PChar(WinToPvrPath(Destination));
				EnterCriticalSection(FBusy);
				EnterCriticalSection(FFileListBusy);
				EnterCriticalSection(FCurDirBusy);
				EnterCriticalSection(FCopyBusy);
				FInCopy := True;
				if UsbTaskFileSendPosi(pDest, pSource, FHandle, TASK_SENDFILE, MSB, LSB) = False then
				begin
					FInCopy := False;
					LeaveCriticalSection(FCopyBusy);
					LeaveCriticalSection(FCurDirBusy);
					LeaveCriticalSection(FFileListBusy);
					LeaveCriticalSection(FBusy);
				end else
				begin
					Result := True;
				end;
			end;
		end;
	end;
end;

{ Cancel CopyFile or CopyFileFromPos }
function TTopfieldReceiver.CancelCopy: Boolean;
begin
	Result := False;
	if (FActive = True) then
	begin
		if FInCopy = True then
		begin
			FInCopy := False;
			LeaveCriticalSection(FCurDirBusy);
			LeaveCriticalSection(FFileListBusy);
			LeaveCriticalSection(FBusy);
			LeaveCriticalSection(FCopyBusy);
			Exit;
		end;
		Result := UsbTaskCancel;
	end;
end;

{ Get the percentage of process using CopyFile or CopyFileFromPos }
function TTopfieldReceiver.GetPercentage: Word;
begin
	Result := 0;
	if (FActive = True) then
	begin
		Result := UsbTaskGetPercent;
	end;
end;

{Expands a FileName in PVR style}
function TTopfieldReceiver.PvrExpandFileName(const FileName: string): string;
var
	sPath, sDir: String;
	sList: TStringList;
	i: Integer;
	bDelimiterAdded: Boolean;
begin
	sPath := FileName;
	if (sPath <> '') then
	begin
		if sPath[1] <> '\' then
		begin
			if (Copy(sPath,1,2) = '.\') then
			begin
				sPath := FCurrentDir + '\' + Copy(sPath, 3, Length(sPath) - 2);
			end else
			begin
				sPath := FCurrentDir + '\' + sPath;
			end;
		end;

		while (Pos('\.\', sPath) > 0) do
			sPath := StringReplace(sPath,'\.\','\', [rfReplaceAll]);

		bDelimiterAdded := False;
		if (sPath[Length(sPath)] <> '\') then
		begin
			sPath := sPath + '\';
			bDelimiterAdded := True;
		end;

		while (Pos('\\', sPath) > 0) do
			sPath := StringReplace(sPath,'\\','\', [rfReplaceAll]);

		sList := TStringList.Create;
		sDir := '';
		for i := 1 to Length(sPath) do
		begin
			if (sPath[i] = '\') then
			begin
				if (sDir = '..') then
				begin
					if (sList.Count > 1) then
						sList.Delete(sList.Count - 1);
				end else
				begin
					sList.Add(sDir);
				end;
				sDir := '';
			end else
			begin
				sDir := sDir + sPath[i];
			end;
		end;
		sPath := '';
		for i := 0 to sList.Count - 1 do
		begin
			sPath := sPath + sList.Strings[i] + '\';
		end;
		sList.Free;
		if ((bDelimiterAdded = True) and (Length(sPath) > 1)) then
			sPath := Copy(sPath, 1, Length(sPath) - 1);
	end;
	Result := sPath;
end;

{Get the file extension part from PVR path}
function TTopfieldReceiver.PvrExtractFileExt(const FileName: string): string;
var
	iLast: Integer;
begin
	iLast := LastDelimiter('.\', FileName);
	if (iLast > 0) and (FileName[iLast] = '.') then
		Result := Copy(FileName, iLast, MaxInt)
	else
    		Result := '';
end;

{Get the file name part from PVR path}
function TTopfieldReceiver.PvrExtractFileName(const FileName: string): string;
var
	iLast: Integer;
begin
	iLast := LastDelimiter('\', FileName);
	Result := Copy(FileName, iLast + 1, MaxInt);
end;

{Get the file path part from PVR path}
function TTopfieldReceiver.PvrExtractFilePath(const FileName: string): string;
var
	iLast: Integer;
begin
	iLast := LastDelimiter('\', FileName);
  	Result := Copy(FileName, 1, iLast);
end;
{------------------------------------------------------------------------------}
{ TTopfieldFileStream }
{------------------------------------------------------------------------------}
{ Constructor }
constructor TTopfieldFileStream.Create(TopfieldReceiver: TTopfieldReceiver; const FileName: string; Mode: Word);
begin
	FTopfieldReceiver := TopfieldReceiver;
	FAccessTopfield := IsTopfieldPath(FileName);

	if FAccessTopfield then
	begin
		if Mode = tpCreate then
		begin
			FHandle := FTopfieldReceiver.FileCreate(FileName);
			if FHandle < 0 then
				{ added by jkit for Delphi4 - 04.04.2005}
				{$IFDEF VER120}
				raise EFCreateError.CreateFmt(SFCreateError, [FileName]);
				{$ELSE}
				raise EFCreateError.CreateResFmt(@SFCreateError, [FileName]);
				{$ENDIF}
		end else
		begin
			FHandle := FTopfieldReceiver.FileOpen(FileName, Mode);
			if FHandle < 0 then
				{ added by jkit for Delphi4 - 04.04.2005}
				{$IFDEF VER120}
				raise EFOpenError.CreateFmt(SFOpenError, [FileName]);
				{$ELSE}
				raise EFOpenError.CreateResFmt(@SFOpenError, [FileName]);
				{$ENDIF}
		end;
	end else
	begin
		if Mode = fmCreate then
		begin
			FHandle := FileCreate(FileName);
			if FHandle < 0 then
				{ added by jkit for Delphi4 - 04.04.2005}
				{$IFDEF VER120}
				raise EFCreateError.CreateFmt(SFCreateError, [FileName]);
				{$ELSE}
				raise EFCreateError.CreateResFmt(@SFCreateError, [FileName]);
				{$ENDIF}
		end else
		begin
			FHandle := FileOpen(FileName, Mode);
			if FHandle < 0 then
				{ added by jkit for Delphi4 - 04.04.2005}
				{$IFDEF VER120}
				raise EFOpenError.CreateFmt(SFOpenError, [FileName]);
				{$ELSE}
				raise EFOpenError.CreateResFmt(@SFOpenError, [FileName]);
				{$ENDIF}
		end;
	end;
end;

{ Destructor }
destructor TTopfieldFileStream.Destroy;
begin
	if FHandle >= 0 then
		if FAccessTopfield then
			FTopfieldReceiver.FileClose(FHandle)
		else
			FileClose(FHandle);
end;
{------------------------------------------------------------------------------}
{ Private procedures and functions}
{------------------------------------------------------------------------------}
{ Get position of large file }
function TTopfieldFileStream.GetPosition64: Int64;
begin
	Result := Seek64(0, 1);
end;

{ Set position of large file }
procedure TTopfieldFileStream.SetPosition64(Pos: Int64);
begin
	Seek64(Pos, 0);
end;

{ Get file size of large file }
function TTopfieldFileStream.GetSize64: Int64;
var
	Pos: Int64;
begin
	Pos := Seek64(0, 1);
	Result := Seek64(0, 2);
	Seek64(Pos, 0);
end;

{------------------------------------------------------------------------------}
{ Protected procedures and functions}
{------------------------------------------------------------------------------}
{ Set file size }
procedure TTopfieldFileStream.SetSize(NewSize: Longint);
begin
	SetSize64(Int64(NewSize));
end;

{ Set file size of large file }
procedure TTopfieldFileStream.SetSize64(NewSize: Int64);
var
	Buffer: byte;
	Count: Integer;
begin
	if FAccessTopfield then
	begin
		Seek64(NewSize, soFromBeginning);
		Count := FTopfieldReceiver.FileWrite(FHandle, Buffer, 0);
		if Count <> 0 then
			raise EPvrError.Create(-Count, 'Error on setting size.');
	end else
	begin
		Seek64(NewSize, soFromBeginning);
		Win32Check(SetEndOfFile(FHandle));
	end;
end;

{------------------------------------------------------------------------------}
{ Public procedures and functions}
{------------------------------------------------------------------------------}
{ Read count bytes from stream }
function TTopfieldFileStream.Read(var Buffer; Count: Longint): Longint;
begin
	if FAccessTopfield then
	begin
		Result := FTopfieldReceiver.FileRead(FHandle, Buffer, Count);
		if Result < 0 then Result := 0;
	end else
	begin
		Result := FileRead(FHandle, Buffer, Count);
		if Result = -1 then Result := 0;
	end;
end;

{ Write count bytes to stream }
function TTopfieldFileStream.Write(const Buffer; Count: Longint): Longint;
begin
	if FAccessTopfield then
	begin
		Result := FTopfieldReceiver.FileWrite(FHandle, Buffer, Count);
		if Result < 0 then Result := 0;
	end else
	begin
		Result := FileWrite(FHandle, Buffer, Count);
		if Result = -1 then Result := 0;
	end;
end;

{ Seek on file stream }
function TTopfieldFileStream.Seek(Offset: Longint; Origin: Word): Longint;
begin
	if FAccessTopfield then
		Result := FTopfieldReceiver.FileSeek(FHandle, Offset, Origin)
	else
		Result := FileSeek(FHandle, Offset, Origin);
end;

{ Seek on large file stream }
function TTopfieldFileStream.Seek64(Offset: Int64; Origin: Word): Int64;
begin
	if FAccessTopfield then
		Result := FTopfieldReceiver.FileSeek(FHandle, Offset, Origin)
	else
		Result := FileSeek(FHandle, Offset, Origin);
end;

{ Copy count bytes from large file steam }
function TTopfieldFileStream.CopyFrom64(Source: TTopfieldFileStream; Count: Int64): Int64;
var
	BufferSize, MoveCount: Integer;
	Buffer: PChar;
begin
	if Count = Int64(0) then
	begin
		Source.Position := 0;
		Count := Source.Size64;
	end;
	Result := Count;
	if Count > Int64(MAX_UsbFileDataSize) then
		BufferSize := MAX_UsbFileDataSize
	else
		BufferSize := Integer(Count);
	GetMem(Buffer, BufferSize);
	try
		while Count > Int64(0) do
		begin
			if Count > Int64(BufferSize) then
			begin
				MoveCount := BufferSize;
				Count := Count - Int64(MoveCount);
			end else
			begin
				MoveCount := Integer(Count);
				Count := 0;
			end;
			Source.ReadBuffer(Buffer^, MoveCount);
			WriteBuffer(Buffer^, MoveCount);
		end;
	finally
		FreeMem(Buffer, BufferSize);
	end;
end;

{------------------------------------------------------------------------------}
{ Register TTopfieldReceiver }
{------------------------------------------------------------------------------}
procedure Register;
begin
  RegisterComponents('Topfield', [TTopfieldReceiver]);
end;

end.
