{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
program tfcopy;
{$APPTYPE CONSOLE}
uses
  classes,
  Windows,
  SysUtils,
  Forms,
  TopfieldReceiver,
  tfdllex;

{$R *.RES}
type
	TEventHandler = class
		procedure ToppyBeforeNotifyDevice(Sender: TObject);
		procedure ToppyAfterNotifyDevice(Sender: TObject);
		procedure ToppyTryNotifyDevice(Sender: TObject);
		procedure ToppyOnAfterCopyFile(Sender: TObject);
		procedure ToppyOnCopyFileFailed(Sender: TObject);
	end;

const tpHeaderSize = 1656;
var
  ToppyDefaultPath: String = 'DataFiles\';
  DisplayOnPercent: Integer = 5;
  xr1: string = '';
  xl1: string = 'ABVGDEJZIYKLMNOPRSTUFHC''''abvgdejziyklmnoprstufhc''''';
  xr2: string = 'ߨ';
  xl2: string = 'CHSHYIYEYUYAYOchshyiyyuyyo';

	sSource, sDest, sListFile: String;
	Toppy: TTopfieldReceiver=Nil;
	stFrom: TTopfieldFileStream = Nil;
  stTo: TTopfieldFileStream = Nil;
  FInfo: TTopfieldFileinfo;
	i, iBuffer, iSourceDest, iCnt, tCnt, iDays, j, maxloop: Integer;
	iFileSize, fcnt, fTot, fread, fstart: Int64;
	Buffer: PChar=Nil;
	Evt: TEventHandler=Nil;
	bUsePvr, bAltairCopy, bEndCopy, bTurbo, bParamOk, bFailedCopy, bError, bSmart,
    bStrip, bDate, bLIST, bListDescr, bReadList, bF, bSourceISO, bDestISO,
    bAppend, bBreak: Boolean;
	dwStart, dwEnd, dwDiff, iSource, iWait, dwSmartStart, dwSmartNow: LongInt;
	sParam: String;
	sSourcePath, sDestPath, sDestMask, sDestName, sMsg: String;
	sSourceFiles: TStringList;
	tpSearchRec: TTopfieldSearchRec;
	pcSearchRec: TSearchRec;
  fWrite, fRename: byte; {0 - skip, 1 - overwrite, 2 - rename }
  pch: PChar;
  ConHandle: THandle; //   
  W, Year, Month, Day, Week: Word;
  H, M: Byte;

procedure TEventHandler.ToppyBeforeNotifyDevice(Sender: TObject);
begin
	WriteLn('Try to detect Topfield device...');
end;

procedure TEventHandler.ToppyAfterNotifyDevice(Sender: TObject);
begin
	WriteLn('Topfield device found. Ready to copy file.');
end;

procedure TEventHandler.ToppyTryNotifyDevice(Sender: TObject);
begin
	WriteLn('Waiting for Topfield device...');
end;

procedure TEventHandler.ToppyOnAfterCopyFile(Sender: TObject);
begin
	bEndCopy := True;
end;

procedure TEventHandler.ToppyOnCopyFileFailed(Sender: TObject);
begin
	bEndCopy := True;
	bFailedCopy := True;
end;

function makeduration(iTick: LongInt): string;
var
	iHour, iMin, iSec, iMSec{, iDummy}: Integer;
begin
{	iDummy := iTick;}
	Result := '';
	iHour := ((iTick div 1000) div 60) div 60;
	if (iHour > 0) then Result := Result + IntToStr(iHour) + ' hour ';

	iTick := iTick - (iHour * 60 * 60 * 1000);
	iMin := (iTick div 1000) div 60;
	if (iMin > 0) then Result := Result + IntToStr(iMin) + ' min ';

	iTick := iTick - (iMin * 60 * 1000);
	iSec := iTick div 1000;
	if (iSec > 0) then Result := Result + IntToStr(iSec) + ' sec ';

	iTick := iTick - (iSec * 1000);
	iMSec := iTick;
	if (iMSec > 0) then Result := Result + IntToStr(iMSec) + ' msec ';
{	Result := Result + '(' + IntToStr(iDummy) + ' msec)';}
end;
function FormatTime(H, M: Byte): String;
begin
  Result := '';
  if(H <= 9) then Result := Result + '0';
  Result := Result + IntToStr(H) + ':';
  if(M <= 9) then Result := Result + '0';
  Result := Result + IntToStr(M);
end;

function MaskRename(sSourceName, sMask: String): String;
var
	i, iMaskLen, iSourceLen, iPos, iCopyLen: Integer;
	sDestName: String;
begin
	iMaskLen := Length(sMask);
	iSourceLen := Length(sSourceName);
	sDestName := '';
	iPos := 1;

	for i := 1 to iMaskLen do
	begin
		if (sMask[i] = '?') then
		begin
			if (iPos <= iSourceLen) then
			begin
				sDestName := sDestName + sSourceName[iPos];
				iPos := iPos + 1;
			end;
		end else if (sMask[i] = '*') then
		begin
			iCopyLen := iSourceLen - iPos + 1;
			if (iCopyLen > 0) then
			begin
				sDestName := sDestName + Copy(sSourceName, iPos, iCopyLen);
				iPos := iPos + iCopyLen;
			end;
		end else
		begin
			sDestName := sDestName + sMask[i];
			iPos := iPos + 1;
		end;
	end;

	if ((Length(sDestName) > 0) and (sDestName[Length(sDestName)] = '.')) then
	begin
		sDestName := Copy(sDestName, 1, Length(sDestName) - 1);
	end;
	Result := sDestName;
end;

function MaskFileRename(sSource, sMask: String): String;
var
	sMaskExt, sSourceExt, sSourceName, sMaskName: String;
begin
	sMaskExt := Toppy.PvrExtractFileExt(sMask);
	if ((Pos('?', sMaskExt) > 0) or (Pos('*', sMaskExt) > 0)) then
	begin
		sSourceExt := Toppy.PvrExtractFileExt(sSource);
		sMaskName := Copy(sMask, 1, Length(sMask) - Length(sMaskExt));
		sSourceName :=  Copy(sSource, 1, Length(sSource) - Length(sSourceExt));
		Result := MaskRename(sSourceName,sMaskName) +  MaskRename(sSourceExt,sMaskExt)
	end else
	begin
		Result := MaskRename(sSource,sMask);
	end;
end;

function MakeOEM(sText: String): String;
begin
	Result := sText;
	CharToOEM(@Result[1], @Result[1]);
end;

function ConvertToWin(sText: String): String;
var
  i, o: Integer;
begin
	Result := sText;
  for i := 1 to Length(Result) do
  begin
    o := Ord(Result[i]);
    if(o >= $B0) and (o <= $EF) then Result[i] := Chr(o + $10)
    else if(o = $A1) then Result[i] := Chr($A8)   { '' }
    else if(o = $F1) then Result[i] := Chr($B8)   { '' }
    else if(o = $F0) then Result[i] := Chr($B9)   { '' }
    else if(o = $FD) then Result[i] := Chr($A7)   { '' }
    else if(o = $FE) then Result[i] := Chr($A2)   { '   ' }
    else if(o = $AE) then Result[i] := Chr($A1)   { '   ' }
    else if(o = $FF) then Result[i] := Chr($9F)   { '  ' }
    else if(o = $AF) then Result[i] := Chr($8F)   { '  ' }
    else if(o = $F4) then Result[i] := Chr($BA)   { ' ' }
    else if(o = $A4) then Result[i] := Chr($AA)   { ' ' }
    else if(o = $FC) then Result[i] := Chr($9D)   { '  ' }
    else if(o = $AC) then Result[i] := Chr($8D)   { '  ' }
    else if(o = $FB) then Result[i] := Chr($9E)   { 'h  ' }
    else if(o = $AB) then Result[i] := Chr($8E)   { 'h   ' }
    else if(o = $FA) then Result[i] := Chr($9C)   { '' }
    else if(o = $AA) then Result[i] := Chr($8C)   { '' }
    else if(o = $F9) then Result[i] := Chr($9A)   { '' }
    else if(o = $A9) then Result[i] := Chr($8A)   { '' }
    else if(o = $F8) then Result[i] := Chr($BC)   { 'j' }
    else if(o = $A8) then Result[i] := Chr($A3)   { 'J' }
    else if(o = $F7) then Result[i] := Chr($BF)   { 'i   ' }
    else if(o = $A7) then Result[i] := Chr($AF)   { 'I   ' }
    else if(o = $F6) then Result[i] := Chr($B3)   { 'i' }
    else if(o = $A6) then Result[i] := Chr($B2)   { 'I' }
    else if(o = $F3) then Result[i] := Chr($83)   { '  ' }
    else if(o = $A3) then Result[i] := Chr($81)   { '  ' }
    else if(o = $F2) then Result[i] := Chr($90)   { '  ' }
    else if(o = $A2) then Result[i] := Chr($80)   { '  ' }
    else if(o = $F5) then Result[i] := Chr($BE)   { 's' }
    else if(o = $A5) then Result[i] := Chr($BD)   { 'S' }
    else if(o = $8A) then Result[i] := Chr($97)   { '-' }
  end;
end;
function ConvertToIso(sText: String): String;
var
  i, o: Integer;
begin
	Result := sText;
  for i := 1 to Length(Result) do
  begin
    o := Ord(Result[i]);
    if(o >= $C0) and (o <= $FF) then Result[i] := Chr(o - $10)
    else if(o = $A8) then Result[i] := Chr($A1)   { '' }
    else if(o = $B8) then Result[i] := Chr($F1)   { '' }
    else if(o = $B9) then Result[i] := Chr($F0)   { '' }
    else if(o = $A7) then Result[i] := Chr($FD)   { '' }
    else if(o = $A2) then Result[i] := Chr($FE)   { '   ' }
    else if(o = $A1) then Result[i] := Chr($AE)   { '   ' }
    else if(o = $9F) then Result[i] := Chr($FF)   { '  ' }
    else if(o = $8F) then Result[i] := Chr($AF)   { '  ' }
    else if(o = $BA) then Result[i] := Chr($F4)   { ' ' }
    else if(o = $AA) then Result[i] := Chr($A4)   { ' ' }
    else if(o = $9D) then Result[i] := Chr($FC)   { '  ' }
    else if(o = $8D) then Result[i] := Chr($AC)   { '  ' }
    else if(o = $9E) then Result[i] := Chr($FB)   { 'h  ' }
    else if(o = $8E) then Result[i] := Chr($AB)   { 'h   ' }
    else if(o = $9C) then Result[i] := Chr($FA)   { '' }
    else if(o = $8C) then Result[i] := Chr($AA)   { '' }
    else if(o = $9A) then Result[i] := Chr($F9)   { '' }
    else if(o = $8A) then Result[i] := Chr($A9)   { '' }
    else if(o = $BC) then Result[i] := Chr($F8)   { 'j' }
    else if(o = $A3) then Result[i] := Chr($A8)   { 'J' }
    else if(o = $BF) then Result[i] := Chr($F7)   { 'i   ' }
    else if(o = $AF) then Result[i] := Chr($A7)   { 'I   ' }
    else if(o = $B3) then Result[i] := Chr($F6)   { 'i' }
    else if(o = $B2) then Result[i] := Chr($A6)   { 'I' }
    else if(o = $83) then Result[i] := Chr($F3)   { '  ' }
    else if(o = $81) then Result[i] := Chr($A3)   { '  ' }
    else if(o = $90) then Result[i] := Chr($F2)   { '  ' }
    else if(o = $80) then Result[i] := Chr($A2)   { '  ' }
    else if(o = $BE) then Result[i] := Chr($F5)   { 's' }
    else if(o = $BD) then Result[i] := Chr($A5)   { 'S' }
    else if(o = $97) then Result[i] := Chr($8A)   { '-' }
  end
end;
function ConvertToWinOpt(sText: String; bflagISO: Boolean): String;
begin
  if(bflagISO) then Result := ConvertToWIN(sText) else Result := sText;
end;
function ConvertToIsoOpt(sText: String; bflagISO: Boolean): String;
begin
  if(bflagISO) then Result := ConvertToISO(sText) else Result := sText;
end;
function ConvertToLat(sText: String): String;
var
  i, j: Integer;
  ch: Char;
begin
	Result := '';
  for i := 1 to Length(sText) do
  begin
    ch := sText[i];
    j := Pos(ch, xr1);
    if (j <> 0) then Result := Result + xl1[j]
    else begin
      j := Pos(ch, xr2);
      if (j <> 0) then Result := Result + xl2[j*2-1] + xl2[j*2]
      else if (ch = '') then Result := Result + 'TSH'
      else if (ch = '') then Result := Result + 'tsh'
      else Result := Result + ch;
    end;
  end;
end;

function StripInavlidChars(sText: String): String;
var
	iTextLen, y, o: Integer;
	ch: Char;
begin
	iTextLen := Length(sText);
	Result := '';
	for y := 1 to iTextLen do
	begin
		ch := sText[y];
		o := Ord(ch);
		if (o > 31) then
		begin
			if not (ch in ['/', '*', '?', '"', '<', '>', '|']) then
        if (ch <> ':') or ((ch = ':') and (y = 2)) then
   				Result := Result + ch;
		end;
	end;
end;
function StripSystemChars(sText: String): String;
var
	iTextLen, y, o: Integer;
	ch: Char;
begin
	iTextLen := Length(sText);
	Result := '';
	for y := 1 to iTextLen do
	begin
		ch := sText[y];
		o := Ord(ch);
		if (o > 31) then
		begin
  		Result := Result + ch;
		end;
	end;
end;

function FormatNumString(sText: String): String;
var
	l: Integer;
begin
  Result := '';
  l := Length(sText);
  repeat
    if (l - 3 <= 0) then begin
      Result := Copy(sText, 1, l) + Result;
      Break;
    end;
    Result := ' ' + Copy(sText, l - 2, 3) + Result;
    l := l - 3;
  until (False);
end;
function ConProc(CtrlType : DWord) : Bool; stdcall; far;
var
 ex: byte;
begin
 case CtrlType of
   CTRL_C_EVENT        : ex := 1;
   CTRL_BREAK_EVENT    : ex := 2;
   CTRL_CLOSE_EVENT    : ex := 3;
   CTRL_LOGOFF_EVENT   : ex := 4;
   CTRL_SHUTDOWN_EVENT : ex := 5;
  else
   ex := 0;
 end;
{ MessageBox(0, PChar(S + ' detected'), 'Win32 Console', MB_OK);}
 if (ex <> 0) then begin
{ 	 if (bUsePvr) and (bSmart or bTurbo) and (Toppy <> Nil) then Toppy.TurboMode := False;
 	 if(Toppy <> Nil) then begin Toppy.Free; Toppy := Nil; end;
   if(Evt <> Nil) then begin Evt.Free; Evt := Nil; end;
   if (stFrom <> Nil) then begin
     stFrom.Free; stFrom := Nil;
   end;
	 if (stTo <> Nil) then begin
     stTo.Free; stTo := Nil;
   end;}
   WriteLn('');
   WriteLn('User break accepted!');
   Result := True;
   if bBreak and (ex = 2) then raise Exception.Create('Break pressed!');
   bBreak := True;
 end else Result := False;
end;

{$INCLUDE tfcopyhelp.pas}
label LoopCheckExist;
begin
	iSourceDest := 0;
	iBuffer := 65024 * 50; {1024 * 1024 * 2;}
	bAltairCopy := False;
	bEndCopy := False;
	bFailedCopy := False;
	bTurbo := False;
	bParamOk := True;
	sSource := '';
	sDest := '';
  sListFile := '';
	Evt := Nil;
	Toppy := Nil;
	Buffer := Nil;
	stTo := Nil;
	sSourceFiles := Nil;
  bLIST := False; bListDescr := False;
  bReadList := False;
	bError := False;
	bSmart := False;
	bStrip := True;
	bDate := False;
	iDays := 0;
	tCnt := 0;
	iWait := 1000;
  fWrite := 0;
  fRename := 0;
  bAppend := False;
  bBreak := False;

	for i := 1 to ParamCount do
	begin
		if (Pos('/', ParamStr(i)) = 1) then
		begin
			sParam := AnsiUpperCase(ParamStr(i));
      if (sParam = '/APPEND') then
      begin
        bAppend := True;
      end else if ((sParam = '/RL') or (sParam = '/RENLAT')) then
      begin
        fRename := 2;
      end else if ((sParam = '/R') or (sParam = '/REN')) then
      begin
        fRename := 1;
      end else if (sParam = '/CR') then
      begin
        fWrite := 2;
      end else if (sParam = '/CO') then
      begin
        fWrite := 1;
      end else if ((sParam = '/L') or (sParam = '/LIST')) then
      begin
        bLIST := True;
      end else if ((sParam = '/E') or (sParam = '/EPG')) then
      begin
        bLIST := True;
        bListDescr := True;
      end else if ((Pos('/LF:',sParam) = 1) or (Pos('/LISTFILE:', sParam) = 1)) then
      begin
        bLIST := True;
        sListFile := Copy(sParam, Pos(':', sParam) + 1, MaxInt);
      end else if ((sParam = '/T') or (sParam = '/TURBO')) then
			begin
				bTurbo := True;
			end else if ((sParam = '/S') or (sParam = '/SMART')) then
			begin
				bSmart := True;
				iWait := 1000;
			end	else if ((Pos('/S:', sParam) = 1) or (Pos('/SMART:', sParam) = 1)) then
			begin
				bSmart := True;
				try
					iWait := StrToInt(Copy(sParam, Pos(':', sParam) + 1, MaxInt));
				except
					bParamOk := False;
				end;
			end else if ((sParam = '/D') or (sParam = '/DATE')) then
			begin
				bDate := True;
			end	else if ((Pos('/D:', sParam) = 1) or (Pos('/DATE:', sParam) = 1)) then
			begin
				bDate := True;
				try
					iDays := StrToInt(Copy(sParam, Pos(':', sParam) + 1, MaxInt));
				except
					bParamOk := False;
				end;
			end else if ((sParam = '/A') or (sParam = '/ALTAIR')) then
			begin
				bAltairCopy := True;
			end else if ((sParam = '/?') or (sParam = '/HELP')) then
			begin
				ShowHelp;
				EXIT;
			end else if ((sParam = '/N') or (sParam = '/NOSTRIP')) then
			begin
				bStrip := False;
			end	else if ((Pos('/B:', sParam) = 1) or (Pos('/BUFFER:', sParam) = 1)) then
			begin
				try
					iBuffer := StrToInt(Copy(sParam, Pos(':', sParam) + 1, MaxInt));
				except
					bParamOk := False;
				end;
			end else
			begin
				bParamOk := False;
			end;
		end else
		begin
			if (iSourceDest < 2) then
			begin
				if (iSourceDest = 0) then begin
					sSource := ParamStr(i);
          if (sSource[1] = '[') then begin
            j := Pos('[',CmdLine);
            sSource := Copy(CmdLine, j+1, Pos(']', CmdLine)-j-1);
            sDest := Copy(CmdLine, Pos(']', CmdLine)+1, MaxInt);
            j := Pos('[',sDest);
            if(j>0) then begin
              sDest := Copy(sDest, j+1, Pos(']', sDest)-j-1);
            end;
    				iSourceDest := iSourceDest + 1;
          end;
				end else sDest := ParamStr(i);
				iSourceDest := iSourceDest + 1;
			end else
			begin
{				bParamOk := False;}
			end;
		end;
	end;
	if ((bParamOk = False) or (sSource = '')) then
	begin
    ShowHelp;
    EXIT;
	end;
  if(bAppend and bAltairCopy) then begin
    WriteLn('Append command is not supported with Altair copy!');
    EXIT;
  end;
  if(sSource[1] = '@') then begin
    bReadList := True;
    sSource := Copy(sSource, 2, MaxInt);
  end;
  if (IsTopfieldPath(sSource) = True) and (Length(sSource) > 2) and (sSource[3] <> '\') { Path like: #:filename }
    then sSource := '#:\'+ToppyDefaultPath+Copy(sSource, 3, MaxInt);
  if (sDest = '#:') then sDest := sDest + '\' + ToppyDefaultPath
  else if (IsTopfieldPath(sDest) = True) and (Length(sDest)>2) and (sDest[3] <> '\') { Path like: #:filename }
    then sDest := '#:\'+ToppyDefaultPath+Copy(sDest, 3, MaxInt);

	try
		Evt := TEventHandler.Create;
		Toppy := TTopfieldReceiver.Create(Application);
		Toppy.OnBeforeNotifyDevice := Evt.ToppyBeforeNotifyDevice;
		Toppy.OnTryNotifyDevice := Evt.ToppyTryNotifyDevice;
		Toppy.OnAfterNotifyDevice := Evt.ToppyAfterNotifyDevice;
		Toppy.OnAfterCopyFile := Evt.ToppyOnAfterCopyFile;
		Toppy.OnCopyFileFailed := Evt.ToppyOnCopyFileFailed;
	except
  	if(Toppy <> Nil) then begin Toppy.Free; Toppy := Nil; end;
    if(Evt <> Nil) then begin Evt.Free; Evt := Nil; end;
		Writeln('Initalization error.');
		EXIT;
	end;

	if (Toppy.DllAvailable = False) then
	begin
 	  if(Toppy <> Nil) then begin Toppy.Free; Toppy := Nil; end;
    if(Evt <> Nil) then begin Evt.Free; Evt := Nil; end;
		Writeln('Can not find TFDLL.DLL.');
		EXIT;
	end;

  Toppy.AttemptRetry := 10;
  SetConsoleCtrlHandler(@ConProc, True);
  {GenerateConsoleCtrlEvent(CTRL_C_EVENT, 0);}
	try
		if ((IsTopfieldPath(sSource) = False) and ((Length(sDest)=0) or (IsTopfieldPath(sDest)= False))) then
		begin
			bUsePvr := False;
			bTurbo := False;
			bAltairCopy := False;
			bSmart := False;
		end else
		begin
			bUsePvr := True;
			if (bAltairCopy = True) then
				bSmart := False;
			if (bSmart = True) then
				bTurbo := True;
			Toppy.StartNotifyDevice;
		end;

		if bUsePvr then
		begin
			while (Toppy.Active = False) and (not bBreak) do
			begin
				Application.ProcessMessages;
			end;
      if (bBreak) then raise Exception.Create('Break pressed!');
		end;
	except
    if(Toppy <> Nil) then begin Toppy.Free; Toppy := Nil; end;
    if(Evt <> Nil) then begin Evt.Free; Evt := Nil; end;
		Writeln('Internal error.');
		EXIT;
	end;
  if (Length(sDest) = 0) then
	begin
    if((IsTopfieldPath(sSource) = True) xor (fRename = 0)) then sDest := '#:\'+ToppyDefaultPath
                                       else sDest := GetCurrentDir;
		if (sDest[Length(sDest)] <> '\') then sDest := sDest + '\';
    if(fRename = 0) then sDest := sDest + Toppy.PvrExtractFileName(sSource);
	end;
  if(fRename <> 0) then fWrite := 2;

	try
		sSourceFiles := TStringList.Create;
    if(bReadList) then begin
      WriteLn('Reading list of files from '+sSource);
      sSourceFiles.LoadFromFile(sSource);
   		for iCnt := 0 to sSourceFiles.Count - 1 do
        if(IsTopfieldPath(sSourceFiles.Strings[iCnt]) = True) then
  			  sSourceFiles.Strings[iCnt] := ConvertToISO(sSourceFiles.Strings[iCnt]);
    end else if (IsTopfieldPath(sSource) = False) then {Source on PC}
		begin
			if FindFirst(sSource, faAnyFile, pcSearchRec) = 0 then
			begin
				repeat
					if not(pcSearchRec.Attr and faDirectory <> 0) then
					begin
						if ((bDate = False) or ((bDate = True) and (FileDateToDateTime(pcSearchRec.Time) >= (Date + iDays)))) then
							sSourceFiles.Add(String(pcSearchRec.FindData.cFileName));
					end;
				until (FindNext(pcSearchRec) <> 0);
			end;
			FindClose(pcSearchRec);
		end else
		begin
			if Toppy.FindFirst(ConvertToISO(sSource), tpAnyFile, tpSearchRec) = 0 then
			begin
				repeat
					if not(tpSearchRec.Attr and tpDirectory <> 0) then
					begin
						if ((bDate = False) or ((bDate = True) and (FileDateToDateTime(tpSearchRec.Time) >= (Date + iDays))))
                and (tpSearchRec.Name <> '_EIT_DATA.DAT') then
              sSourceFiles.Add(tpSearchRec.Name);
					end;
				until (Toppy.FindNext(tpSearchRec) <> 0);
			end;
			Toppy.FindClose(tpSearchRec);
		end;
	except
		if (sSourceFiles <> Nil) then sSourceFiles.Free;
 	  if(Toppy <> Nil) then begin Toppy.Free; Toppy := Nil; end;
    if(Evt <> Nil) then begin Evt.Free; Evt := Nil; end;
		Writeln('Internal error. Unable to create list.');
		EXIT;
	end;

  if not(bReadList) then begin
  	sSourcePath := Toppy.PvrExtractFilePath(sSource);
	  if ((Length(sSourcePath) > 1) and (sSourcePath[Length(sSourcePath)] <> '\')) then
		  sSourcePath := sSourcePath + '\';
  end else sSourcePath := '';

	sDestPath := Toppy.PvrExtractFilePath(sDest);
  if(fRename <> 0) and (Length(sDestPath)=0) then sDestPath := ConvertToWinOpt(Toppy.PvrExtractFilePath(sSource),IsTopfieldPath(sSource));
	if ((Length(sDestPath) > 1) and (sDestPath[Length(sDestPath)] <> '\')) then
		sDestPath := sDestPath + '\';

	sDestMask := Toppy.PvrExtractFileName(sDest);
	if (sDestMask = '') then sDestMask := '*';

	if (sSourceFiles.Count = 0) or (bBreak) then
	begin
		sSourceFiles.Free;
 	  if(Toppy <> Nil) then begin Toppy.Free; Toppy := Nil; end;
    if(Evt <> Nil) then begin Evt.Free; Evt := Nil; end;
    if(not bBreak) then
    	Writeln('File not found: ' +  MakeOEM(sSource));
		EXIT;
	end;

  if(bLIST) then begin
      bError := False;
      fCnt := 0;
	  	for iCnt := 0 to sSourceFiles.Count - 1 do
	  	begin
        sSource := sSourcePath + sSourceFiles.Strings[iCnt];
        if(IsTopfieldPath(sSource) = True) then
          WriteLn(MakeOEM(ConvertToWin(sSource)))
        else
          WriteLn(MakeOEM(sSource));
        if(bListDescr) then begin
          stFrom := Nil;
          Buffer := Nil;
      		try
	  	    	stFrom := TTopfieldFileStream.Create(Toppy, sSource, tpOpenRead or tpShareDenyNone);
        		iFileSize := stFrom.Size64;
            fCnt := fCnt + iFileSize;
            if (iFileSize >= tpHeaderSize) then begin
              GetMem(Buffer, tpHeaderSize);
              iSource := stFrom.Read(Buffer^, tpHeaderSize);
              if (iSource = tpHeaderSize) then begin
                if (Copy(Buffer, 1, 4) = 'TFrc') then begin
                  Write('Size: '+ FormatNumString(IntToStr(iFileSize))+' bytes, ');
                  W := Get16bit(Pointer(Buffer+8));  {Record Duration 2 bytes}
                  Write(IntToStr(W)+' min, ');
                  W := Get16bit(Pointer(Buffer+76)); {Event Start day}
                  H := Byte(Buffer[78]);             {Event Start Hour}
                  M := Byte(Buffer[79]);             {Event Start Min}
                  H := H + Byte(Buffer[84]);         {Local time offset}
                  if(H >= 24) then begin
                    H := H - 24;
                    W := W + 1;
                  end;
                  ExtractMjd(W, @Year, @Month, @Day, @Week);
                  Write(IntToStr(Day)+'.');
                  if(Month <= 9) then Write('0');
                  Write(IntToStr(Month)+'.'+IntToStr(Year)+' ');
                  Write(FormatTime(H, M)+'. ');
                  pch := Buffer + 28;                {Service Name 24 bytes}
                  sMsg := pch;
                  WriteLn(MakeOEM(StripSystemChars(ConvertToWin(sMsg))));
                  pch := Buffer + 87;                {Event text 129 bytes}
                  sMsg := pch;
                  WriteLn('EPG: '+MakeOEM(StripSystemChars(ConvertToWin(sMsg))));
                  WriteLn('');
                end;
              end else WriteLn('Can not read from file! Only '+FormatNumString(IntToStr(iSource))+' bytes read.');
              FreeMem(Buffer, tpHeaderSize);
            end;
            stFrom.Free;
	  		  except
	  			  Writeln('Can not open file!');
            if (stFrom <> Nil) then stFrom.Free;
            if (Buffer <> Nil) then FreeMem(Buffer, tpHeaderSize);
	  			  EXIT;
	  		  end;
        end;
        if (bBreak) then break;
      end;
      if not(bError) then begin
        Write('Found '+IntToStr(iCnt)+' files.');
        if(bListDescr) then Write(' Total: '+FormatNumString(IntToStr(fCnt))+' bytes.');
        Writeln('');
        if(Length(sListFile)>0) then begin
          sSourceFiles.SaveToFile(sListFile);
          Writeln('List saved to '+MakeOEM(sListFile));
        end;
      end;
	  	sSourceFiles.Free;
  	  if(Toppy <> Nil) then begin Toppy.Free; Toppy := Nil; end;
      if(Evt <> Nil) then begin Evt.Free; Evt := Nil; end;
      EXIT;
  end;

  fTot := 0;
	try
  	if (bAltairCopy = False) then GetMem(Buffer, iBuffer);
		for iCnt := 0 to sSourceFiles.Count - 1 do
		begin
      if bBreak then break;
      fstart := 0; fread := 0;
			sSource := sSourcePath + sSourceFiles.Strings[iCnt];
      if(IsTopfieldPath(sSource) = True) then bSourceISO := True else bSourceISO := False;
			sDestName := MaskFileRename(sSourceFiles.Strings[iCnt], ConvertToIsoOpt(sDestMask,bSourceISO));
			sDest := ConvertToIsoOpt(sDestPath,bSourceISO) + sDestName;
      bDestISO := bSourceISO;
      if(IsTopfieldPath(sDest) = True) and (not bDestISO) then begin
          sDest := ConvertToISO(sDest);
          bDestISO := True;
      end else if(IsTopfieldPath(sDest) = False) and (bDestISO) then begin
          sDest := ConvertToWIN(sDest);
          bDestISO := False;
      end;
			if (bStrip) and (((IsTopfieldPath(sSource) = True) and (IsTopfieldPath(sDest)=False)) or
                      (fRename<>0)) then sDest := StripInavlidChars(sDest);

			if (fRename<>2) and (((IsTopfieldPath(sSource) = True) and (sSource = sDest)) or
				((IsTopfieldPath(sSource) = False) and (AnsiUpperCase(sSource) = AnsiUpperCase(sDest)))) then
			begin
				Writeln('Can not process file: ' + MakeOEM(ConvertToWinOpt(sSource,bSourceISO)));
				Writeln('Source and destination must be different.');
				EXIT;
			end;
      if(fRename = 2) then sDest := ConvertToLAT(ConvertToWinOpt(sDest,bDestISO));
      if (not bAppend) and ((fWrite = 0) or (fWrite = 2)) then
      begin
        Maxloop := 0;
LoopCheckExist:
        bf := False;
        if(IsTopfieldPath(sDest)=True) then begin
          if (Toppy.FileExists(sDest)) then bf := True;
        end else if (FileExists(sDest)) then bf := True;
        if(fWrite = 0) then begin {skip file}
          if (bf) then begin
            WriteLn('Skip file: '+MakeOEM(ConvertToWinOpt(sDest,bDestISO)));
            Continue;
          end;
        end else if(fWrite = 2) then begin {rename file}
          if (bf) then
          begin
           {if (MaxLoop = 0) and (fRename = 0)then
            WriteLn('Rename file: '+MakeOEM(ConvertToWinOpt(sDest,bDestISO)));}
            j := LastDelimiter('\.', sDest);
            if (j>1) and (sDest[j] = '.') then
            begin
              if (sDest[j-1] >= '1') and (sDest[j-1] <= '8') then
                sDest := Copy(sDest, 1, j-2) + Chr(Ord(sDest[j-1])+1) + Copy(sDest, j, MaxInt)
              else sDest := Copy(sDest, 1, j-1) + '-1' + Copy(sDest, j, MaxInt);
            end else begin
             if (sDest[j-1] >= '1') and (sDest[j-1] <= '8') then begin
               sDest := Copy(sDest, 1, Length(sDest)-1) + Chr(Ord(Length(sDest))+1);
             end else sDest := sDest + '-1';
            end;
            Maxloop := Maxloop + 1;
            if (Maxloop>999) or (bBreak) then begin
              Writeln('Can not rename file many times!');
              EXIT;
            end;
            goto LoopCheckExist;
          end;
        end;
      end;
      if (fRename <> 0) then begin
        if (bDestISO) then bf := Toppy.RenameFile(sSource, sDest)
                      else bf := RenameFile(sSource, sDest);
        if (bf) then begin
          WriteLn('Rename: '+MakeOEM(ConvertToWinOpt(sSource,bSourceISO))+
            ' to '+MakeOEM(ConvertToWinOpt(sDest,bDestISO)));
          Inc(tCnt);
        end else begin
          WriteLn('Error renaming file: '+MakeOEM(ConvertToWinOpt(sSource,bSourceISO))+
            ' to '+MakeOEM(ConvertToWinOpt(sDest,bDestISO)));
        end;
        Continue;
      end;

			try
				stFrom := TTopfieldFileStream.Create(Toppy, sSource, tpOpenRead or tpShareExclusive);
			except
				Writeln('Can not open file: ' +  MakeOEM(ConvertToWINOpt(sSource,bSourceISO)));
     	  if(Toppy <> Nil) then begin Toppy.Free; Toppy := Nil; end;
        if(Evt <> Nil) then begin Evt.Free; Evt := Nil; end;
				EXIT;
			end;
			iFileSize := stFrom.Size64;
			if (bAltairCopy) then begin stFrom.Free; stFrom := Nil; end;
			if not(bAltairCopy) then
			begin
        if(bAppend) then begin
          if(sSourceFiles.Count <> 1) then begin
             stFrom.Free; stFrom := Nil;
             WriteLn('Append allowed only on 1 file!');
             Exit;
          end;
				  try
          	stTo := TTopfieldFileStream.Create(Toppy, sDest, tpOpenReadWrite);
          except
          	Writeln('Can not open file for append: ' + MakeOEM(ConvertToWinOpt(sDest,bDestISO)));
          	EXIT;
          end;
          fstart := stTo.Size64;
          if (fstart >= iFileSize) then begin
            WriteLn('Size of destination file: '+MakeOEM(ConvertToWinOpt(sDest,bDestISO))+
            ' already is: '+FormatNumString(IntToStr(fstart)));
            stFrom.Free; stFrom := Nil;
            Exit;
          end;
          try
            stFrom.Seek64(fstart, 0);
            stTo.Seek64(fstart,0);
          except
            WriteLn('Error seek file!');
            exit;
          end;
        end else begin
  			  try
	      		stTo := TTopfieldFileStream.Create(Toppy, sDest, tpCreate);
		  		except
					  Writeln('Can not create file: ' + MakeOEM(ConvertToWinOpt(sDest,bDestISO)));
  					EXIT;
	  			end;
        end;
			end;

			try
				try
					try
						if (iCnt = 0) then begin
							if (bUsePvr) then
							begin
								try
									Toppy.TurboMode := bTurbo;
								finally
									bTurbo := Toppy.TurboMode;
								end;
							end;
							Write('Status: Turbo Mode = ');
							if (bTurbo) then
								Write('[ON], Altair Mode = ')
							else
								Write('[OFF], Altair Mode = ');
							if not(bAltairCopy) then
								WriteLn('[OFF], Buffer Size = [' + IntToStr(iBuffer) + ' Byte]')
							else
								WriteLn('[ON], Buffer Size = [NONE]');
						end else
						begin
							WriteLn('');
						end;
            Write('Copy file: ');
						sMsg := Copy(sSource, LastDelimiter('\', sSource) + 1, MaxInt) + ' (' + FormatNumString(IntToStr(iFileSize)) + ' Bytes)';
						WriteLn(MakeOEM(ConvertToWinOpt(sMsg,bSourceISO)));
            if(bAppend) then WriteLn('Starting at: ' + FormatNumString(IntToStr(fstart)));
            Write('To: '+MakeOEM(ConvertToWinOpt(sDest,bDestISO)));

            dwEnd := 0;
						if not(bAltairCopy) then begin
							dwStart := GetTickCount;
              fcnt := (iFileSize-fstart) div iBuffer * DisplayOnPercent div 100;
              j := 0;
              fread := fstart;
							repeat
								iSource := stFrom.Read(Buffer^, iBuffer);
                if (iSource = 0)  then break
                                  else stTo.Write(Buffer^,iSource);
                fread := fread + iSource;
								if (bSmart) then
								begin
									Toppy.TurboMode := False;
									dwSmartStart := GetTickCount;
									repeat
										dwSmartNow := GetTickCount;
										Application.ProcessMessages;
									until ((dwSmartNow - dwSmartStart) >= iWait);
									Toppy.TurboMode := True;
								end;
                j := j + 1;
                if (j > fcnt) then begin
                  Write('.');
                  j := 0;
                end;
							until (fread >= iFileSize) or (bBreak);
              if (fread <> iFileSize) or (bBreak) then bError := True;
							dwEnd := GetTickCount;
						end else
						begin
              fread := fstart;
							dwStart := GetTickCount;
							dwSmartStart := dwStart;
              j := DisplayOnPercent;
							Toppy.CopyFile(sSource, sDest);
							while (not bEndCopy) and (not bBreak) do
							begin
								Application.ProcessMessages;
    						dwSmartNow := GetTickCount;
                if((dwSmartNow - dwSmartStart) >= iWait) then begin
                  dwSmartStart := GetTickCount;
                  if (Toppy.GetPercentage() >= j) then begin
                    Write('.');
                    j := j + DisplayOnPercent;
                  end;
                end;
							end;
              if(bBreak) then begin Toppy.CancelCopy; bError := True; end;
							dwEnd := GetTickCount;
              fread := stTo.Size64;
						end;
						if (not bFailedCopy) and (not bError) then
						begin
							Writeln('');
							Write('Copy done: ');
							dwDiff :=  dwEnd - dwStart;
							Write(makeduration(dwDiff)+' ('+ FormatNumString(IntToStr((fread-fstart) div (dwDiff div 1000+1))) + ' bytes/sec)');
              tCnt := tCnt + 1;
						end else
						begin
							bError := True;
							EXIT;
						end;
					except
						bError := True;
						EXIT;
					end;
				except
					bError := True;
					EXIT;
				end;
			finally
	  		if (stFrom <> Nil) then begin
          stFrom.Free; stFrom := Nil;
        end;
	  		if (stTo <> Nil) then begin
          stTo.Free; stTo := Nil;
        end;
        if (dwEnd = 0) then dwEnd := GetTickCount;
        if (dwEnd = dwStart) then dwEnd := dwEnd + 1;
        if(bError) then begin
					Writeln('');
					Writeln('Copy failed!');
					dwDiff := dwEnd - dwStart;
					Write(makeduration(dwDiff));
          if(fread>0) then
            WriteLn('. Read: '+FormatNumString(IntToStr(fread-fstart))+ ' ('+ FormatNumString(IntToStr((fread-fstart) div (dwDiff div 1000+1))) + ' bytes/sec)');
					bError := True;
        end;
        fTot := fTot + fread - fstart;
			end;
		end;
	finally
    SetConsoleCtrlHandler(@ConProc, False);
    if (bUsePvr) and (bSmart or bTurbo) and (Toppy <> Nil) then Toppy.TurboMode := False;
		if (not bAltairCopy) and (Buffer <> Nil) then FreeMem(Buffer, iBuffer); Buffer := Nil;
 	  if(Toppy <> Nil) then begin Toppy.Free; Toppy := Nil; end;
    if(Evt <> Nil) then begin Evt.Free; Evt := Nil; end;
		Writeln('');
    if(fRename<>0) then
      WriteLn(IntToStr(tCnt) + ' files renamed.')
    else
  		Writeln(IntToStr(tCnt) + ' files copied. Total: '+FormatNumString(IntToStr(fTot))+' bytes.');
		sSourceFiles.Free;
	end;
end.

