procedure ShowHelp;
begin
	Writeln('TFCOPY Source Destination [/A] [B | B:Size] [/D | /D:Days] [/N] [/CO | /CR]');
  Writeln('  [/L[F:file name]] [/E] [/R[L]] [/S | /S:Idle] [/T] [/APPEND] [/?]');
  Writeln('Version 1.1.6R, Modified by Vadim Kulakov. Email: vad7@yahoo.com');
  WriteLn('                                   (Original version 1.0 at www.8ung.at/aldarin)');
	Writeln('');
	Writeln('Parameters:');
	Writeln('-----------');
	Writeln('Source      Required. Specifies the location from which you want to copy a file.');
	Writeln('            If the first letter "@" file list will be read from file.');
	Writeln('            Source can consist of a drive letter and colon, a folder name, a');
	Writeln('            file name, or a combination of these. If you want to access the');
	Writeln('            harddrive of your Topfield receiver use the hash # character for');
	Writeln('            the drive letter. ');
	Writeln('Destination Specifies the location to which you want to copy a file (like source).');
	Writeln('/A          Copies the file(s) in the way as Altair does. This option only take');
	Writeln('            effect, if files are copied from or to your receivers harddrive.');
	Writeln('/B:Size     This option allows you to set the buffer size in bytes used by the');
	Writeln('            copy process. It is ignored when the option /A is set. Change the');
	Writeln('            size if the copy process should use smaller or larger blocks.');
	Writeln('            If you don''t use the /A and /B:Size option a default of 8Mb is used.');
	Writeln('/D or       Copies source files created on or after the current date only.');
	Writeln('/D:Days     With the optional flag [Days] you can set the amount of days');
	Writeln('            the current date is scaled up or down. Setting [Days] to a');
	Writeln('            negativ value will scale down the current date, a positiv');
	Writeln('            value will increase the current date.');
	Writeln('            eg.: Setting [Days] to -1 (/D:-1) will copy only files which');
	Writeln('            were created after yesterday.');
	Writeln('/N          Suppresses stripping of invalid characters from the destination');
	Writeln('            file name.');
	Writeln('/S or       Enables the smart turbo mode for the copy process. This option');
	Writeln('/S:Idle     only take effect, if files are copied from or to your receivers');
	Writeln('            harddrive. It is ignored when the option /A is set. When the /S');
	Writeln('            parameter is set the turbo mode of the receiver is switched on for');
	Writeln('            each block copied. The block size used equals to the buffer size');
	Writeln('            given by the parameter /B. After a block is copied the copy');
	Writeln('            process will turn the turbo mode off and wait [Idle] milliseconds.');
	Writeln('            After this idle time the turbo mode is turned on and the next block');
	Writeln('            will be copied. The default value of the idle time is 1000 ms. The');
	Writeln('            smart turbo mode gives you the chance to use your remote control');
	Writeln('            when files are copied.');
	Writeln('/T          Enables the turbo mode of the receiver. This option only take');
	Writeln('            effect, if files are copied from or to your receivers harddrive.');
	Writeln('/L or /LIST Types list of files which will be processed.');
	Writeln('/E or /EPG  Types on the screen file EPG event');
	Writeln('/LF:file    Writes list of files to a specified file (alias "/LISTFILE:").');
	Writeln('/CO         When the file is exist overwrite it (default skip).');
	Writeln('/CR         When the file is exist rename it - add number at the end.');
	Writeln('/R or /REN  Rename files by mask and skip invalid characters.');
	Writeln('/RL or      Rename files by mask, skip invalid characters and replace');
	Writeln('/RENLAT     russian character to latinica.');
  Writeln('/APPEND     Continue copy one file (append to the end). Dont work in Altair mode.');
	Writeln('');
	Writeln('');
	Writeln('Installation:');
	Writeln('-------------');
	Writeln('Just put the EXE - File (tfcopy.exe) in a directory of your choice. You have to');
	Writeln('start TFCOPY from the command line. Only PVR Systems can be accessed which are');
	Writeln('supported by Topfield''s file management tool Altair. You will need the tfdll.dll');
	Writeln('Ver. 1.005 which comes with Altair Ver.1.250. Please download Altair from');
	Writeln('TOPFIELD Co., Ltd. (http://i-topfield.com) and copy the file tfdll.dll to a');
	Writeln('directory where TFCopy has access to it (e.g. to your system directory).');
	Writeln('');
	Writeln('Usage:');
	Writeln('------');
	Writeln('If you want to access the harddrive of your Topfield receiver use the hash #');
	Writeln('character for the drive letter. If either source or destination points to your');
	Writeln('receivers harddrive the path and file name is case sensitiv.');
	Writeln('Quote the path name if a blank is within the name.');
	Writeln('');
	Writeln('eg.: tfcopy "#:\DataFiles\My File.rec" "C:\Test\My File.rec"');
	Writeln('');
	Writeln('TFCopy supports the use of wildcards "*" and "?" either in the source or');
	Writeln('destination path, on PVR "DataFiles" is default directory.');
	Writeln('');
	Writeln('eg.: tfcopy #:* C:\test\*');
	Writeln('');
	Writeln('Examples:');
	Writeln('---------');
	Writeln('tfcopy C:\test\test.txt D:\test\test.txt');
	Writeln('tfcopy [#:\DataFiles\Test file.rec] [C:\test\"Test file".rec] /A');
	Writeln('tfcopy C:\test\Test.rec #:Test.rec /T /B:3145728');
	Writeln('tfcopy #:\DataFiles\Test.rec C:\test\Test.rec /S:2000');
	Writeln('tfcopy #:\DataFiles\*.* C:\test\*.* /CR');
	Writeln('tfcopy #:*.* C:\test\*.* /D:-1');
	Writeln('tfcopy #:* /LF:c:\list.txt /EPG');
{  WriteLN(MAKEOEM(ConvertToWin(#224#213#214)));}
end;
