{Aldarin's Topfield PVR Components Suite 1.1
Copyright 2004, 2005 by Aldarin
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit tfdllex;

interface
uses
	Windows;

const
{--------------------------------------------------------------------------------------------------}
{ Translated from tfdllex.h }
{--------------------------------------------------------------------------------------------------}
	MAX_UsbSendBlockSize 	= $10000;
	MAX_UsbBlockSize 		= $ffff;
	MAX_UsbFileDataSize 	= $fe00;

	MAX_UsbDataSize 		= (MAX_UsbBlockSize - 16);
{--------------------------------------------------------------------------------------------------}
	USB_CmdNone 			= $00000000;

	USB_Fail 				= $00000001;
	USB_Success 			= $00000002;
	USB_Cancel 				= $00000003;

	USB_CmdReady 			= $00000100;
	USB_CmdReset 			= $00000101;
	USB_CmdTurbo 			= $00000102;
{--------------------------------------------------------------------------------------------------}
{ Hdd Cmd }
{--------------------------------------------------------------------------------------------------}
	USB_CmdHddSize 			= $00001000;
	USB_DataHddSize 		= $00001001;

	USB_CmdHddDir 			= $00001002;
	USB_DataHddDir 			= $00001003;
	USB_DataHddDirEnd 		= $00001004;

	USB_CmdHddDel 			= $00001005;
	USB_CmdHddRename 		= $00001006;
	USB_CmdHddCreateDir 	= $00001007;

	USB_CmdHddFileSend 		= $00001008;
	USB_DataHddFileStart 	= $00001009;
	USB_DataHddFileData 	= $0000100A;
	USB_DataHddFileEnd 		= $0000100B;
{--------------------------------------------------------------------------------------------------}
{ Usb Error Code }
{--------------------------------------------------------------------------------------------------}
	USB_OK 					= $00000000;
	USB_Err_Crc 			= $00000001;
	USB_Err_UnknownCmd 		= $00000002;
	USB_Err_InvalidCmd 		= $00000003;
	USB_Err_Unknown 		= $00000004;
	USB_Err_Size 			= $00000005;
	USB_Err_RunFail 		= $00000006;
	USB_Err_Memory 			= $00000007;

	USB_Err_FileOpen		= $00000008;
	USB_Err_FileCreate		= $00000009;
	USB_Err_FileWrite		= $0000000a;
	USB_Err_Receive			= $0000000b;
	USB_Err_FileAccessError	= $0000000c;
	USB_Err_TaskCancel		= $0000000d;
	USB_Err_STBWorkError	= $0000000e;
{--------------------------------------------------------------------------------------------------}
{ File send direct }
{--------------------------------------------------------------------------------------------------}
	USB_FileToDevice 		= $00;
	USB_FileToHost 			= $01;
{--------------------------------------------------------------------------------------------------}
{ File Attribute }
{--------------------------------------------------------------------------------------------------}
	USB_FileTypeFolder 		= $01;
	USB_FileTypeNormal 		= $02;
	USB_FileTypeTS			= $03;
	USB_FileTypeExe			= $04;
{--------------------------------------------------------------------------------------------------}
	USB_FileTypeSize 		= 114;
	USB_FileNameSize 		= 95;
{--------------------------------------------------------------------------------------------------}

{--------------------------------------------------------------------------------------------------}
{ from tfdllex.h }
{--------------------------------------------------------------------------------------------------}
type
	TInitDevice				=	procedure; cdecl;
	TDeviceArrival			=	function (pDeviceName: PChar): BOOL; cdecl;
	TDeviceRemoval			=	function (pDeviceName: PChar): BOOL; cdecl;
	TGetDeviceVidPid		=	function (pVid: PDWORD; pPid: PDWORD): BOOL; cdecl;
	TStartPnpNotice			=	function (hwnd: HWND): BOOL; cdecl;
	TTryDeviceOpen			=	function : BOOL; cdecl;
	TGetDeviceVersion		=	function (pVersion: PWORD): BOOL; cdecl;
{--------------------------------------------------------------------------------------------------}
	TUsbWrite				=	function (pBuf: PByte; size: DWORD): BOOL; cdecl;
	TUsbRead				=	function (pBuf: PByte; size: DWORD): DWORD; cdecl;
	TUsbCommandSend			=	function (cmd: DWORD; pBuf: PByte; size: DWORD): BOOL; cdecl;
{--------------------------------------------------------------------------------------------------}
	TGetCrc16				=	function (data: Pointer; n: DWORD): Word; cdecl;
	TGet16bit				=	function (p: Pointer): Word; cdecl;
	TPut16bit				=	procedure (p: Pointer; data: Word); cdecl;
	TGet24bit				=	function (p: Pointer): DWORD; cdecl;
	TPut24bit				=	procedure (p: Pointer; data: DWORD); cdecl;
	TGet32bit				=	function (p: Pointer): DWORD; cdecl;
	TPut32bit				=	procedure (p: Pointer; data: DWORD); cdecl;
	TExtractMjd				=	function (mjd: Word; year: PWORD; month: PByte; day: PByte;
									weekDay: PByte): Byte; cdecl;
	TMakeMjd				=	function (year: Word; month: Byte; day: Byte): Word; cdecl;
{--------------------------------------------------------------------------------------------------}
// highPosi : high-order word of file size
// lowPosi  : low-order double word of file size
	TUsbTaskFileSend		=	function (pDestName: PChar; pSrcName: PChar; hWnd: HWND;
									wParam: WPARAM): BOOL; cdecl;
	TUsbTaskFileSendPosi	=	function (pDestName: PChar; pSrcName: PChar; hWnd: HWND;
									wParam: WPARAM; highPosi: DWORD; lowPosi: DWORD): BOOL; cdecl;
	TUsbTaskGetPercent		=	function : Word; cdecl;
	TUsbTaskCancel			=	function : BOOL; cdecl;
	TUsbTaskFileReceive		=	function (pDestName: PChar; pSrcName: PChar;
									hWnd: HWND; wParam: WPARAM): BOOL; cdecl;
	TUsbTaskFileReceivePosi	=	function (pDestName: PChar; pSrcName: PChar; hWnd: HWND;
									wParam: WPARAM; highPosi: DWORD; lowPosi: DWORD): BOOL; cdecl;

{--------------------------------------------------------------------------------------------------}
{ Externals from tfdll.dll }
{--------------------------------------------------------------------------------------------------}
var
	InitDevice: TInitDevice = nil;
	DeviceArrival: TDeviceArrival = nil;
	DeviceRemoval: TDeviceRemoval = nil;
	GetDeviceVidPid: TGetDeviceVidPid = nil;
	StartPnpNotice: TStartPnpNotice = nil;
	TryDeviceOpen: TTryDeviceOpen = nil;
	GetDeviceVersion: TGetDeviceVersion = nil;
{--------------------------------------------------------------------------------------------------}
	UsbWrite: TUsbWrite = nil;
	UsbRead: TUsbRead = nil;
	UsbCommandSend: TUsbCommandSend = nil;
{--------------------------------------------------------------------------------------------------}
	GetCrc16: TGetCrc16 = nil;
	Get16bit: TGet16bit = nil;
	Put16bit: TPut16bit = nil;
	Get24bit: TGet24bit = nil;
	Put24bit: TPut24bit = nil;
	Get32bit: TGet32bit = nil;
	Put32bit: TPut32bit = nil;
	ExtractMjd: TExtractMjd = nil;
	MakeMjd: TMakeMjd = nil;
{--------------------------------------------------------------------------------------------------}
	UsbTaskFileSend: TUsbTaskFileSend = nil;
	UsbTaskFileSendPosi: TUsbTaskFileSendPosi = nil;
	UsbTaskGetPercent: TUsbTaskGetPercent = nil;
	UsbTaskCancel: TUsbTaskCancel = nil;
	UsbTaskFileReceive: TUsbTaskFileReceive = nil;
	UsbTaskFileReceivePosi: TUsbTaskFileReceivePosi = nil;
{--------------------------------------------------------------------------------------------------}
{ TFDllLoaded }
{--------------------------------------------------------------------------------------------------}
function TFDllLoaded: Boolean;

implementation

var
	tfDllHandle: THandle;

{--------------------------------------------------------------------------------------------------}
{ Load tfdll.dll }
{--------------------------------------------------------------------------------------------------}
procedure LoadTFDll;
begin
	tfDllHandle := LoadLibrary('TFDLL.DLL');
	if (tfDllHandle <> 0) then
	begin
		InitDevice := GetProcAddress(tfDllHandle, 'InitDevice');
		DeviceArrival := GetProcAddress(tfDllHandle, 'DeviceArrival');
		DeviceRemoval := GetProcAddress(tfDllHandle, 'DeviceRemoval');
		GetDeviceVidPid := GetProcAddress(tfDllHandle, 'GetDeviceVidPid');
		StartPnpNotice := GetProcAddress(tfDllHandle, 'StartPnpNotice');
		TryDeviceOpen := GetProcAddress(tfDllHandle, 'TryDeviceOpen');
		GetDeviceVersion := GetProcAddress(tfDllHandle, 'GetDeviceVersion');
		UsbWrite := GetProcAddress(tfDllHandle, 'UsbWrite');
		UsbRead := GetProcAddress(tfDllHandle, 'UsbRead');
		UsbCommandSend := GetProcAddress(tfDllHandle, 'UsbCommandSend');
		GetCrc16 := GetProcAddress(tfDllHandle, 'GetCrc16');
		Get16bit := GetProcAddress(tfDllHandle, 'Get16bit');
		Put16bit := GetProcAddress(tfDllHandle, 'Put16bit');
		Get24bit := GetProcAddress(tfDllHandle, 'Get24bit');
		Put24bit := GetProcAddress(tfDllHandle, 'Put24bit');
		Get32bit := GetProcAddress(tfDllHandle, 'Get32bit');
		Put32bit := GetProcAddress(tfDllHandle, 'Put32bit');
		ExtractMjd := GetProcAddress(tfDllHandle, 'ExtractMjd');
		MakeMjd := GetProcAddress(tfDllHandle, 'MakeMjd');
		UsbTaskFileSend := GetProcAddress(tfDllHandle, 'UsbTaskFileSend');
		UsbTaskFileSendPosi := GetProcAddress(tfDllHandle, 'UsbTaskFileSendPosi');
		UsbTaskGetPercent := GetProcAddress(tfDllHandle, 'UsbTaskGetPercent');
		UsbTaskCancel := GetProcAddress(tfDllHandle, 'UsbTaskCancel');
		UsbTaskFileReceive := GetProcAddress(tfDllHandle, 'UsbTaskFileReceive');
		UsbTaskFileReceivePosi := GetProcAddress(tfDllHandle, 'UsbTaskFileReceivePosi');
	end else
	begin
		InitDevice := nil;
		DeviceArrival := nil;
		DeviceRemoval := nil;
		GetDeviceVidPid := nil;
		StartPnpNotice := nil;
		TryDeviceOpen := nil;
		GetDeviceVersion := nil;
		UsbWrite := nil;
		UsbRead := nil;
		UsbCommandSend := nil;
		GetCrc16 := nil;
		Get16bit := nil;
		Put16bit := nil;
		Get24bit := nil;
		Put24bit := nil;
		Get32bit := nil;
		Put32bit := nil;
		ExtractMjd := nil;
		MakeMjd := nil;
		UsbTaskFileSend := nil;
		UsbTaskFileSendPosi := nil;
		UsbTaskGetPercent := nil;
		UsbTaskCancel := nil;
		UsbTaskFileReceive := nil;
		UsbTaskFileReceivePosi := nil;
	end;
end;

{--------------------------------------------------------------------------------------------------}
{ Free tfdll.dll }
{--------------------------------------------------------------------------------------------------}

procedure FreeTFDll;
begin
	FreeLibrary(tfDllHandle);
	tfDllHandle := 0;
	InitDevice := nil;
	DeviceArrival := nil;
	DeviceRemoval := nil;
	GetDeviceVidPid := nil;
	StartPnpNotice := nil;
	TryDeviceOpen := nil;
	GetDeviceVersion := nil;
	UsbWrite := nil;
	UsbRead := nil;
	UsbCommandSend := nil;
	GetCrc16 := nil;
	Get16bit := nil;
	Put16bit := nil;
	Get24bit := nil;
	Put24bit := nil;
	Get32bit := nil;
	Put32bit := nil;
	ExtractMjd := nil;
	MakeMjd := nil;
	UsbTaskFileSend := nil;
	UsbTaskFileSendPosi := nil;
	UsbTaskGetPercent := nil;
	UsbTaskCancel := nil;
	UsbTaskFileReceive := nil;
	UsbTaskFileReceivePosi := nil;
end;

{--------------------------------------------------------------------------------------------------}
{ Returns the load status }
{--------------------------------------------------------------------------------------------------}

function TFDllLoaded: Boolean;
begin
	Result := (tfDllHandle <> 0);
end;

initialization
	LoadTFDll;

finalization
	FreeTFDll;
end.

